/////////////////////////////////////////90////////////////////////////////////////////
#pragma once

#ifndef _IKUCHENBASAR
#define _IKUCHENBASAR
#include "IKuchenBasar.h"
#endif

#include "Kuchen.h"
#include "Gast.h"
#include "Bestellung.h"

#include "DBAssistent.h"
#include "KuchenBasarListe.h"
#include "KuchenWerte.h"
#include "GaesteWerte.h"

namespace KuchenBasar {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	public ref class FormMain : public System::Windows::Forms::Form, IKuchenBasar
	{

	private:
		int aktGaesteID;
		int aktKuchenID;
		int aktBestellungenID;

	public:
		virtual property int AktGaesteID
		{
			virtual void set(int value)
			{
				aktGaesteID = value;
			}

			virtual int get()
			{
				return aktGaesteID;
			}
		}

		virtual property int AktKuchenID
		{
			virtual void set(int value)
			{
				aktKuchenID = value;
			}

			virtual int get()
			{
				return aktKuchenID;
			}
		}

		virtual property int AktBestellungenID
		{
			virtual void set(int value)
			{
				aktBestellungenID = value;
			}

			virtual int get()
			{
				return aktBestellungenID;
			}
		}

	public:
		DBAssistent^ dbAssistent;

		FormMain(void)
		{
			InitializeComponent();

			dbAssistent = gcnew DBAssistent();

			aktGaesteID = 0;
			aktKuchenID = 0;
			aktBestellungenID = 0;

			refreshGaesteDaten();
			refreshKuchenDaten();
			refreshBestellungenDaten();
		}

	protected:

		~FormMain()
		{
			if (components)
			{
				delete components;
			}
		}

	private: System::Windows::Forms::TabControl^  tabControl1;

	private: System::Windows::Forms::TabPage^  tabPageGaeste;
	private: System::Windows::Forms::SplitContainer^  splitContainerGaeste;
	private: System::Windows::Forms::DataGridView^  dataGridViewGaeste;

	private: System::Windows::Forms::TextBox^  textBoxGaesteName;
	private: System::Windows::Forms::TextBox^  textBoxGaesteVorname;
	private: System::Windows::Forms::TextBox^  textBoxGaesteKurzName;
	private: System::Windows::Forms::TextBox^  textBoxGaesteEinrichtung;
	private: System::Windows::Forms::TextBox^  textBoxGaesteTelefon;
	private: System::Windows::Forms::TextBox^  textBoxGaesteBestellungen;

	private: System::Windows::Forms::Label^  labelGaesteName;
	private: System::Windows::Forms::Label^  labelGaesteVorname;
	private: System::Windows::Forms::Label^  labelGaesteKurzName;
	private: System::Windows::Forms::Label^  labelGaesteEinrichtung;
	private: System::Windows::Forms::Label^  labelGaesteTelefon;
	private: System::Windows::Forms::Label^  labelGaesteBestellungen;

	private: System::Windows::Forms::TextBox^  textBoxGaesteFiltern;
	private: System::Windows::Forms::CheckBox^  checkBoxGaesteFiltern;
	private: System::Windows::Forms::Label^  labelGaesteFiltern;
    private: System::Windows::Forms::Button^  buttonGaesteAendern;

	private: System::Windows::Forms::Button^  buttonGaesteNeu;
	private: System::Windows::Forms::Button^  buttonGaesteLoeschen;

	private: System::Windows::Forms::TabPage^  tabPageKuchen;
	private: System::Windows::Forms::SplitContainer^  splitContainerKuchen;
	private: System::Windows::Forms::DataGridView^  dataGridViewKuchen;

	private: System::Windows::Forms::TextBox^  textBoxKuchenAnbieter;
	private: System::Windows::Forms::TextBox^  textBoxKuchenSorte;
	private: System::Windows::Forms::TextBox^  textBoxKuchenBeschreibung;
	private: System::Windows::Forms::TextBox^  textBoxKuchenAnzahl;
	private: System::Windows::Forms::TextBox^  textBoxKuchenAbgabedatum;
    private: System::Windows::Forms::TextBox^  textBoxKuchenDiabetikergeeignet;
	private: System::Windows::Forms::TextBox^  textBoxKuchenKurzName;
	private: System::Windows::Forms::TextBox^  textBoxKuchenPreis;
	private: System::Windows::Forms::TextBox^  textBoxKuchenBestellt;

    private: System::Windows::Forms::Label^  labelKuchenAnbieter;
	private: System::Windows::Forms::Label^  labelKuchenSorte;
	private: System::Windows::Forms::Label^  labelKuchenBeschreibung;
	private: System::Windows::Forms::Label^  labelKuchenAnzahl;
	private: System::Windows::Forms::Label^  labelKuchenAbgabedatum;
	private: System::Windows::Forms::Label^  labelKuchenDiabetikergeeignet;
	private: System::Windows::Forms::Label^  labelKuchenKurzName;
	private: System::Windows::Forms::Label^  labelKuchenPreis;
	private: System::Windows::Forms::Label^  labelKuchenBestellt;

	private: System::Windows::Forms::TextBox^  textBoxKuchenFiltern;
	private: System::Windows::Forms::CheckBox^  checkBoxKuchenFiltern;
	private: System::Windows::Forms::Label^  labelKuchenFilter;

	private: System::Windows::Forms::Button^  buttonKuchenNeu;
	private: System::Windows::Forms::Button^  buttonKuchenLoeschen;
    private: System::Windows::Forms::Button^  buttonKuchenAendern;

	private: System::Windows::Forms::TabPage^  tabPageBestellungen;
	private: System::Windows::Forms::SplitContainer^  splitContainerBestellungen;
	private: System::Windows::Forms::DataGridView^  dataGridViewBestellungen;

	private: System::Windows::Forms::ComboBox^  comboBoxBestellungenKuchenID;
	private: System::Windows::Forms::ComboBox^  comboBoxBestellungenGaesteID;
	private: System::Windows::Forms::DateTimePicker^  dateTimePickerBestellungenDatum;
	private: System::Windows::Forms::NumericUpDown^  numericUpDownBestellungenMenge;
	private: System::Windows::Forms::NumericUpDown^  numericUpDownBestellungenPreis;

	private: System::Windows::Forms::CheckBox^  checkBoxBestellungenBezahlt;
	private: System::Windows::Forms::CheckBox^  checkBoxBestellungenGeliefert;

	private: System::Windows::Forms::Label^  labelBestellungenGaesteID;
	private: System::Windows::Forms::Label^  labelBestellungenKuchenID;
	private: System::Windows::Forms::Label^  labelBestellungenMenge;
	private: System::Windows::Forms::Label^  labelBestellungenDatum;
	private: System::Windows::Forms::Label^  labelBestellungenPreis;

	private: System::Windows::Forms::CheckBox^  checkBoxBestellungenFiltern;
	private: System::Windows::Forms::TextBox^  textBoxBestellungenFiltern;
	private: System::Windows::Forms::Label^  labelBestellungenFiltern;

	private: System::Windows::Forms::Button^  buttonBestellungenNeu;
	private: System::Windows::Forms::Button^  buttonBestellungenLoeschen;
	private: System::Windows::Forms::Button^  buttonBestellungenSpeichern;

	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  dateiToolStripMenuItem;

	private: System::Windows::Forms::ToolStripMenuItem^  listeToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  beendenToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  infoToolStripMenuItem;

	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
			this->splitContainerGaeste = (gcnew System::Windows::Forms::SplitContainer());
			this->dataGridViewGaeste = (gcnew System::Windows::Forms::DataGridView());
			this->textBoxGaesteBestellungen = (gcnew System::Windows::Forms::TextBox());
			this->labelGaesteBestellungen = (gcnew System::Windows::Forms::Label());
			this->textBoxGaesteFiltern = (gcnew System::Windows::Forms::TextBox());
			this->checkBoxGaesteFiltern = (gcnew System::Windows::Forms::CheckBox());
			this->labelGaesteFiltern = (gcnew System::Windows::Forms::Label());
			this->textBoxGaesteName = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteVorname = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteKurzName = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteEinrichtung = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteTelefon = (gcnew System::Windows::Forms::TextBox());
			this->labelGaesteName = (gcnew System::Windows::Forms::Label());
			this->labelGaesteVorname = (gcnew System::Windows::Forms::Label());
			this->labelGaesteKurzName = (gcnew System::Windows::Forms::Label());
			this->labelGaesteEinrichtung = (gcnew System::Windows::Forms::Label());
			this->labelGaesteTelefon = (gcnew System::Windows::Forms::Label());
			this->buttonGaesteNeu = (gcnew System::Windows::Forms::Button());
			this->buttonGaesteLoeschen = (gcnew System::Windows::Forms::Button());
			this->buttonGaesteAendern = (gcnew System::Windows::Forms::Button());
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->dateiToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->listeToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->beendenToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->infoToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->tabControl1 = (gcnew System::Windows::Forms::TabControl());
			this->tabPageBestellungen = (gcnew System::Windows::Forms::TabPage());
			this->splitContainerBestellungen = (gcnew System::Windows::Forms::SplitContainer());
			this->dataGridViewBestellungen = (gcnew System::Windows::Forms::DataGridView());
			this->numericUpDownBestellungenPreis = (gcnew System::Windows::Forms::NumericUpDown());
			this->labelBestellungenPreis = (gcnew System::Windows::Forms::Label());
			this->checkBoxBestellungenGeliefert = (gcnew System::Windows::Forms::CheckBox());
			this->checkBoxBestellungenBezahlt = (gcnew System::Windows::Forms::CheckBox());
			this->comboBoxBestellungenKuchenID = (gcnew System::Windows::Forms::ComboBox());
			this->comboBoxBestellungenGaesteID = (gcnew System::Windows::Forms::ComboBox());
			this->checkBoxBestellungenFiltern = (gcnew System::Windows::Forms::CheckBox());
			this->labelBestellungenMenge = (gcnew System::Windows::Forms::Label());
			this->labelBestellungenDatum = (gcnew System::Windows::Forms::Label());
			this->dateTimePickerBestellungenDatum = (gcnew System::Windows::Forms::DateTimePicker());
			this->numericUpDownBestellungenMenge = (gcnew System::Windows::Forms::NumericUpDown());
			this->textBoxBestellungenFiltern = (gcnew System::Windows::Forms::TextBox());
			this->labelBestellungenFiltern = (gcnew System::Windows::Forms::Label());
			this->labelBestellungenGaesteID = (gcnew System::Windows::Forms::Label());
			this->labelBestellungenKuchenID = (gcnew System::Windows::Forms::Label());
			this->buttonBestellungenNeu = (gcnew System::Windows::Forms::Button());
			this->buttonBestellungenLoeschen = (gcnew System::Windows::Forms::Button());
			this->buttonBestellungenSpeichern = (gcnew System::Windows::Forms::Button());
			this->tabPageKuchen = (gcnew System::Windows::Forms::TabPage());
			this->splitContainerKuchen = (gcnew System::Windows::Forms::SplitContainer());
			this->dataGridViewKuchen = (gcnew System::Windows::Forms::DataGridView());
			this->labelKuchenBestellt = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenBestellt = (gcnew System::Windows::Forms::TextBox());
			this->labelKuchenPreis = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenPreis = (gcnew System::Windows::Forms::TextBox());
			this->labelKuchenKurzName = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenKurzName = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenDiabetikergeeignet = (gcnew System::Windows::Forms::TextBox());
			this->labelKuchenDiabetikergeeignet = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenAnzahl = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenAbgabedatum = (gcnew System::Windows::Forms::TextBox());
			this->checkBoxKuchenFiltern = (gcnew System::Windows::Forms::CheckBox());
			this->labelKuchenAnzahl = (gcnew System::Windows::Forms::Label());
			this->labelKuchenAbgabedatum = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenFiltern = (gcnew System::Windows::Forms::TextBox());
			this->labelKuchenFilter = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenAnbieter = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenSorte = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenBeschreibung = (gcnew System::Windows::Forms::TextBox());
			this->labelKuchenAnbieter = (gcnew System::Windows::Forms::Label());
			this->labelKuchenSorte = (gcnew System::Windows::Forms::Label());
			this->labelKuchenBeschreibung = (gcnew System::Windows::Forms::Label());
			this->buttonKuchenNeu = (gcnew System::Windows::Forms::Button());
			this->buttonKuchenLoeschen = (gcnew System::Windows::Forms::Button());
			this->buttonKuchenAendern = (gcnew System::Windows::Forms::Button());
			this->tabPageGaeste = (gcnew System::Windows::Forms::TabPage());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerGaeste))->BeginInit();
			this->splitContainerGaeste->Panel1->SuspendLayout();
			this->splitContainerGaeste->Panel2->SuspendLayout();
			this->splitContainerGaeste->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewGaeste))->BeginInit();
			this->menuStrip1->SuspendLayout();
			this->tabControl1->SuspendLayout();
			this->tabPageBestellungen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerBestellungen))->BeginInit();
			this->splitContainerBestellungen->Panel1->SuspendLayout();
			this->splitContainerBestellungen->Panel2->SuspendLayout();
			this->splitContainerBestellungen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewBestellungen))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numericUpDownBestellungenPreis))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numericUpDownBestellungenMenge))->BeginInit();
			this->tabPageKuchen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerKuchen))->BeginInit();
			this->splitContainerKuchen->Panel1->SuspendLayout();
			this->splitContainerKuchen->Panel2->SuspendLayout();
			this->splitContainerKuchen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewKuchen))->BeginInit();
			this->tabPageGaeste->SuspendLayout();
			this->SuspendLayout();
			// 
			// splitContainerGaeste
			// 
			this->splitContainerGaeste->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitContainerGaeste->Location = System::Drawing::Point(3, 3);
			this->splitContainerGaeste->Name = L"splitContainerGaeste";
			// 
			// splitContainerGaeste.Panel1
			// 
			this->splitContainerGaeste->Panel1->Controls->Add(this->dataGridViewGaeste);
			// 
			// splitContainerGaeste.Panel2
			// 
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteBestellungen);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteBestellungen);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteFiltern);
			this->splitContainerGaeste->Panel2->Controls->Add(this->checkBoxGaesteFiltern);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteFiltern);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteName);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteVorname);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteKurzName);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteEinrichtung);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteTelefon);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteName);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteVorname);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteKurzName);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteEinrichtung);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteTelefon);
			this->splitContainerGaeste->Panel2->Controls->Add(this->buttonGaesteNeu);
			this->splitContainerGaeste->Panel2->Controls->Add(this->buttonGaesteLoeschen);
			this->splitContainerGaeste->Panel2->Controls->Add(this->buttonGaesteAendern);
			this->splitContainerGaeste->Size = System::Drawing::Size(1206, 474);
			this->splitContainerGaeste->SplitterDistance = 651;
			this->splitContainerGaeste->TabIndex = 0;
			// 
			// dataGridViewGaeste
			// 
			this->dataGridViewGaeste->AllowUserToAddRows = false;
			this->dataGridViewGaeste->AllowUserToDeleteRows = false;
			this->dataGridViewGaeste->AutoSizeColumnsMode = System::Windows::Forms::DataGridViewAutoSizeColumnsMode::Fill;
			this->dataGridViewGaeste->AutoSizeRowsMode = System::Windows::Forms::DataGridViewAutoSizeRowsMode::AllCells;
			this->dataGridViewGaeste->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewGaeste->Dock = System::Windows::Forms::DockStyle::Fill;
			this->dataGridViewGaeste->Location = System::Drawing::Point(0, 0);
			this->dataGridViewGaeste->MultiSelect = false;
			this->dataGridViewGaeste->Name = L"dataGridViewGaeste";
			this->dataGridViewGaeste->ReadOnly = true;
			this->dataGridViewGaeste->SelectionMode = System::Windows::Forms::DataGridViewSelectionMode::FullRowSelect;
			this->dataGridViewGaeste->Size = System::Drawing::Size(651, 474);
			this->dataGridViewGaeste->TabIndex = 0;
			this->dataGridViewGaeste->SelectionChanged += gcnew System::EventHandler(this, &FormMain::selectGaesteElement_Click);
			// 
			// textBoxGaesteBestellungen
			// 
			this->textBoxGaesteBestellungen->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteBestellungen->Location = System::Drawing::Point(192, 282);
			this->textBoxGaesteBestellungen->Name = L"textBoxGaesteBestellungen";
			this->textBoxGaesteBestellungen->ReadOnly = true;
			this->textBoxGaesteBestellungen->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteBestellungen->TabIndex = 17;
			// 
			// labelGaesteBestellungen
			// 
			this->labelGaesteBestellungen->AutoSize = true;
			this->labelGaesteBestellungen->Location = System::Drawing::Point(84, 289);
			this->labelGaesteBestellungen->Name = L"labelGaesteBestellungen";
			this->labelGaesteBestellungen->Size = System::Drawing::Size(68, 13);
			this->labelGaesteBestellungen->TabIndex = 16;
			this->labelGaesteBestellungen->Text = L"Bestellungen";
			// 
			// textBoxGaesteFiltern
			// 
			this->textBoxGaesteFiltern->Enabled = false;
			this->textBoxGaesteFiltern->Location = System::Drawing::Point(240, 339);
			this->textBoxGaesteFiltern->Name = L"textBoxGaesteFiltern";
			this->textBoxGaesteFiltern->Size = System::Drawing::Size(190, 20);
			this->textBoxGaesteFiltern->TabIndex = 15;
			this->textBoxGaesteFiltern->TextChanged += gcnew System::EventHandler(this, &FormMain::textBoxGaesteFiltern_TextChanged);
			// 
			// checkBoxGaesteFiltern
			// 
			this->checkBoxGaesteFiltern->AutoSize = true;
			this->checkBoxGaesteFiltern->Location = System::Drawing::Point(87, 348);
			this->checkBoxGaesteFiltern->Name = L"checkBoxGaesteFiltern";
			this->checkBoxGaesteFiltern->Size = System::Drawing::Size(54, 17);
			this->checkBoxGaesteFiltern->TabIndex = 14;
			this->checkBoxGaesteFiltern->Text = L"Filtern";
			this->checkBoxGaesteFiltern->UseVisualStyleBackColor = true;
			this->checkBoxGaesteFiltern->CheckedChanged += gcnew System::EventHandler(this, &FormMain::checkBoxGaesteFiltern_CheckedChanged);
			// 
			// labelGaesteFiltern
			// 
			this->labelGaesteFiltern->AutoSize = true;
			this->labelGaesteFiltern->Location = System::Drawing::Point(174, 349);
			this->labelGaesteFiltern->Name = L"labelGaesteFiltern";
			this->labelGaesteFiltern->Size = System::Drawing::Size(31, 13);
			this->labelGaesteFiltern->TabIndex = 13;
			this->labelGaesteFiltern->Text = L"nach";
			// 
			// textBoxGaesteName
			// 
			this->textBoxGaesteName->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteName->Location = System::Drawing::Point(192, 33);
			this->textBoxGaesteName->Name = L"textBoxGaesteName";
			this->textBoxGaesteName->ReadOnly = true;
			this->textBoxGaesteName->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteName->TabIndex = 2;
			// 
			// textBoxGaesteVorname
			// 
			this->textBoxGaesteVorname->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteVorname->Location = System::Drawing::Point(192, 75);
			this->textBoxGaesteVorname->Name = L"textBoxGaesteVorname";
			this->textBoxGaesteVorname->ReadOnly = true;
			this->textBoxGaesteVorname->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteVorname->TabIndex = 3;
			// 
			// textBoxGaesteKurzName
			// 
			this->textBoxGaesteKurzName->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteKurzName->Location = System::Drawing::Point(192, 127);
			this->textBoxGaesteKurzName->Name = L"textBoxGaesteKurzName";
			this->textBoxGaesteKurzName->ReadOnly = true;
			this->textBoxGaesteKurzName->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteKurzName->TabIndex = 4;
			// 
			// textBoxGaesteEinrichtung
			// 
			this->textBoxGaesteEinrichtung->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteEinrichtung->Location = System::Drawing::Point(192, 183);
			this->textBoxGaesteEinrichtung->Name = L"textBoxGaesteEinrichtung";
			this->textBoxGaesteEinrichtung->ReadOnly = true;
			this->textBoxGaesteEinrichtung->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteEinrichtung->TabIndex = 5;
			// 
			// textBoxGaesteTelefon
			// 
			this->textBoxGaesteTelefon->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteTelefon->Location = System::Drawing::Point(192, 231);
			this->textBoxGaesteTelefon->Name = L"textBoxGaesteTelefon";
			this->textBoxGaesteTelefon->ReadOnly = true;
			this->textBoxGaesteTelefon->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteTelefon->TabIndex = 6;
			// 
			// labelGaesteName
			// 
			this->labelGaesteName->AutoSize = true;
			this->labelGaesteName->Location = System::Drawing::Point(106, 40);
			this->labelGaesteName->Name = L"labelGaesteName";
			this->labelGaesteName->Size = System::Drawing::Size(35, 13);
			this->labelGaesteName->TabIndex = 0;
			this->labelGaesteName->Text = L"Name";
			// 
			// labelGaesteVorname
			// 
			this->labelGaesteVorname->AutoSize = true;
			this->labelGaesteVorname->Location = System::Drawing::Point(92, 82);
			this->labelGaesteVorname->Name = L"labelGaesteVorname";
			this->labelGaesteVorname->Size = System::Drawing::Size(49, 13);
			this->labelGaesteVorname->TabIndex = 0;
			this->labelGaesteVorname->Text = L"Vorname";
			// 
			// labelGaesteKurzName
			// 
			this->labelGaesteKurzName->AutoSize = true;
			this->labelGaesteKurzName->Location = System::Drawing::Point(92, 130);
			this->labelGaesteKurzName->Name = L"labelGaesteKurzName";
			this->labelGaesteKurzName->Size = System::Drawing::Size(54, 13);
			this->labelGaesteKurzName->TabIndex = 0;
			this->labelGaesteKurzName->Text = L"Kurzname";
			// 
			// labelGaesteEinrichtung
			// 
			this->labelGaesteEinrichtung->AutoSize = true;
			this->labelGaesteEinrichtung->Location = System::Drawing::Point(86, 186);
			this->labelGaesteEinrichtung->Name = L"labelGaesteEinrichtung";
			this->labelGaesteEinrichtung->Size = System::Drawing::Size(60, 13);
			this->labelGaesteEinrichtung->TabIndex = 0;
			this->labelGaesteEinrichtung->Text = L"Einrichtung";
			// 
			// labelGaesteTelefon
			// 
			this->labelGaesteTelefon->AutoSize = true;
			this->labelGaesteTelefon->Location = System::Drawing::Point(98, 234);
			this->labelGaesteTelefon->Name = L"labelGaesteTelefon";
			this->labelGaesteTelefon->Size = System::Drawing::Size(43, 13);
			this->labelGaesteTelefon->TabIndex = 0;
			this->labelGaesteTelefon->Text = L"Telefon";
			// 
			// buttonGaesteNeu
			// 
			this->buttonGaesteNeu->Location = System::Drawing::Point(341, 389);
			this->buttonGaesteNeu->Name = L"buttonGaesteNeu";
			this->buttonGaesteNeu->Size = System::Drawing::Size(89, 48);
			this->buttonGaesteNeu->TabIndex = 12;
			this->buttonGaesteNeu->Text = L"Neu";
			this->buttonGaesteNeu->UseVisualStyleBackColor = true;
			this->buttonGaesteNeu->Click += gcnew System::EventHandler(this, &FormMain::buttonGaesteNeu_Click);
			// 
			// buttonGaesteLoeschen
			// 
			this->buttonGaesteLoeschen->Enabled = false;
			this->buttonGaesteLoeschen->Location = System::Drawing::Point(207, 389);
			this->buttonGaesteLoeschen->Name = L"buttonGaesteLoeschen";
			this->buttonGaesteLoeschen->Size = System::Drawing::Size(89, 48);
			this->buttonGaesteLoeschen->TabIndex = 11;
			this->buttonGaesteLoeschen->Text = L"Lschen";
			this->buttonGaesteLoeschen->UseVisualStyleBackColor = true;
			this->buttonGaesteLoeschen->Click += gcnew System::EventHandler(this, &FormMain::buttonGaesteLoeschen_Click);
			// 
			// buttonGaesteAendern
			// 
			this->buttonGaesteAendern->Enabled = false;
			this->buttonGaesteAendern->Location = System::Drawing::Point(65, 389);
			this->buttonGaesteAendern->Name = L"buttonGaesteAendern";
			this->buttonGaesteAendern->Size = System::Drawing::Size(89, 48);
			this->buttonGaesteAendern->TabIndex = 10;
			this->buttonGaesteAendern->Text = L"ndern";
			this->buttonGaesteAendern->UseVisualStyleBackColor = true;
			this->buttonGaesteAendern->Click += gcnew System::EventHandler(this, &FormMain::buttonGaesteAendern_Click);
			// 
			// menuStrip1
			// 
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {
				this->dateiToolStripMenuItem,
					this->infoToolStripMenuItem
			});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(1220, 24);
			this->menuStrip1->TabIndex = 0;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// dateiToolStripMenuItem
			// 
			this->dateiToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {
				this->listeToolStripMenuItem,
					this->beendenToolStripMenuItem
			});
			this->dateiToolStripMenuItem->Name = L"dateiToolStripMenuItem";
			this->dateiToolStripMenuItem->Size = System::Drawing::Size(46, 20);
			this->dateiToolStripMenuItem->Text = L"Datei";
			// 
			// listeToolStripMenuItem
			// 
			this->listeToolStripMenuItem->Name = L"listeToolStripMenuItem";
			this->listeToolStripMenuItem->Size = System::Drawing::Size(120, 22);
			this->listeToolStripMenuItem->Text = L"Liste";
			this->listeToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::listeToolStripMenuItem_Click);
			// 
			// beendenToolStripMenuItem
			// 
			this->beendenToolStripMenuItem->Name = L"beendenToolStripMenuItem";
			this->beendenToolStripMenuItem->Size = System::Drawing::Size(120, 22);
			this->beendenToolStripMenuItem->Text = L"Beenden";
			this->beendenToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::beendenToolStripMenuItem_Click);
			// 
			// infoToolStripMenuItem
			// 
			this->infoToolStripMenuItem->Name = L"infoToolStripMenuItem";
			this->infoToolStripMenuItem->Size = System::Drawing::Size(40, 20);
			this->infoToolStripMenuItem->Text = L"Info";
			this->infoToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::infoToolStripMenuItem_Click);
			// 
			// tabControl1
			// 
			this->tabControl1->Controls->Add(this->tabPageBestellungen);
			this->tabControl1->Controls->Add(this->tabPageKuchen);
			this->tabControl1->Controls->Add(this->tabPageGaeste);
			this->tabControl1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tabControl1->Location = System::Drawing::Point(0, 24);
			this->tabControl1->Name = L"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(1220, 506);
			this->tabControl1->TabIndex = 0;
			this->tabControl1->SelectedIndexChanged += gcnew System::EventHandler(this, &FormMain::tabControl1_SelectedIndexChanged);
			// 
			// tabPageBestellungen
			// 
			this->tabPageBestellungen->Controls->Add(this->splitContainerBestellungen);
			this->tabPageBestellungen->Location = System::Drawing::Point(4, 22);
			this->tabPageBestellungen->Name = L"tabPageBestellungen";
			this->tabPageBestellungen->Padding = System::Windows::Forms::Padding(3);
			this->tabPageBestellungen->Size = System::Drawing::Size(1212, 480);
			this->tabPageBestellungen->TabIndex = 1;
			this->tabPageBestellungen->Text = L"Bestellungen";
			this->tabPageBestellungen->UseVisualStyleBackColor = true;
			// 
			// splitContainerBestellungen
			// 
			this->splitContainerBestellungen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitContainerBestellungen->Location = System::Drawing::Point(3, 3);
			this->splitContainerBestellungen->Name = L"splitContainerBestellungen";
			// 
			// splitContainerBestellungen.Panel1
			// 
			this->splitContainerBestellungen->Panel1->Controls->Add(this->dataGridViewBestellungen);
			// 
			// splitContainerBestellungen.Panel2
			// 
			this->splitContainerBestellungen->Panel2->Controls->Add(this->numericUpDownBestellungenPreis);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenPreis);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->checkBoxBestellungenGeliefert);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->checkBoxBestellungenBezahlt);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->comboBoxBestellungenKuchenID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->comboBoxBestellungenGaesteID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->checkBoxBestellungenFiltern);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenMenge);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenDatum);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->dateTimePickerBestellungenDatum);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->numericUpDownBestellungenMenge);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->textBoxBestellungenFiltern);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenFiltern);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenGaesteID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenKuchenID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->buttonBestellungenNeu);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->buttonBestellungenLoeschen);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->buttonBestellungenSpeichern);
			this->splitContainerBestellungen->Size = System::Drawing::Size(1206, 474);
			this->splitContainerBestellungen->SplitterDistance = 648;
			this->splitContainerBestellungen->TabIndex = 1;
			// 
			// dataGridViewBestellungen
			// 
			this->dataGridViewBestellungen->AllowUserToAddRows = false;
			this->dataGridViewBestellungen->AllowUserToDeleteRows = false;
			this->dataGridViewBestellungen->AutoSizeColumnsMode = System::Windows::Forms::DataGridViewAutoSizeColumnsMode::Fill;
			this->dataGridViewBestellungen->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewBestellungen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->dataGridViewBestellungen->Location = System::Drawing::Point(0, 0);
			this->dataGridViewBestellungen->Name = L"dataGridViewBestellungen";
			this->dataGridViewBestellungen->ReadOnly = true;
			this->dataGridViewBestellungen->SelectionMode = System::Windows::Forms::DataGridViewSelectionMode::FullRowSelect;
			this->dataGridViewBestellungen->Size = System::Drawing::Size(648, 474);
			this->dataGridViewBestellungen->TabIndex = 0;
			this->dataGridViewBestellungen->SelectionChanged += gcnew System::EventHandler(this, &FormMain::selectBestellungenElement_Click);
			// 
			// numericUpDownBestellungenPreis
			// 
			this->numericUpDownBestellungenPreis->DecimalPlaces = 2;
			this->numericUpDownBestellungenPreis->Increment = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1, 0, 0, 65536 });
			this->numericUpDownBestellungenPreis->Location = System::Drawing::Point(192, 231);
			this->numericUpDownBestellungenPreis->Maximum = System::Decimal(gcnew cli::array< System::Int32 >(4) { 1000000000, 0, 0, 0 });
			this->numericUpDownBestellungenPreis->Name = L"numericUpDownBestellungenPreis";
			this->numericUpDownBestellungenPreis->Size = System::Drawing::Size(238, 20);
			this->numericUpDownBestellungenPreis->TabIndex = 25;
			// 
			// labelBestellungenPreis
			// 
			this->labelBestellungenPreis->AutoSize = true;
			this->labelBestellungenPreis->Location = System::Drawing::Point(127, 238);
			this->labelBestellungenPreis->Name = L"labelBestellungenPreis";
			this->labelBestellungenPreis->Size = System::Drawing::Size(30, 13);
			this->labelBestellungenPreis->TabIndex = 24;
			this->labelBestellungenPreis->Text = L"Preis";
			// 
			// checkBoxBestellungenGeliefert
			// 
			this->checkBoxBestellungenGeliefert->AutoSize = true;
			this->checkBoxBestellungenGeliefert->Location = System::Drawing::Point(298, 280);
			this->checkBoxBestellungenGeliefert->Name = L"checkBoxBestellungenGeliefert";
			this->checkBoxBestellungenGeliefert->Size = System::Drawing::Size(65, 17);
			this->checkBoxBestellungenGeliefert->TabIndex = 23;
			this->checkBoxBestellungenGeliefert->Text = L"Geliefert";
			this->checkBoxBestellungenGeliefert->UseVisualStyleBackColor = true;
			// 
			// checkBoxBestellungenBezahlt
			// 
			this->checkBoxBestellungenBezahlt->AutoSize = true;
			this->checkBoxBestellungenBezahlt->Location = System::Drawing::Point(192, 280);
			this->checkBoxBestellungenBezahlt->Name = L"checkBoxBestellungenBezahlt";
			this->checkBoxBestellungenBezahlt->Size = System::Drawing::Size(61, 17);
			this->checkBoxBestellungenBezahlt->TabIndex = 6;
			this->checkBoxBestellungenBezahlt->Text = L"Bezahlt";
			this->checkBoxBestellungenBezahlt->UseVisualStyleBackColor = true;
			// 
			// comboBoxBestellungenKuchenID
			// 
			this->comboBoxBestellungenKuchenID->FormattingEnabled = true;
			this->comboBoxBestellungenKuchenID->Location = System::Drawing::Point(192, 92);
			this->comboBoxBestellungenKuchenID->Name = L"comboBoxBestellungenKuchenID";
			this->comboBoxBestellungenKuchenID->Size = System::Drawing::Size(238, 21);
			this->comboBoxBestellungenKuchenID->TabIndex = 3;
			this->comboBoxBestellungenKuchenID->SelectedIndexChanged += gcnew System::EventHandler(this, &FormMain::comboBoxBestellungenKuchenID_SelectedIndexChanged);
			// 
			// comboBoxBestellungenGaesteID
			// 
			this->comboBoxBestellungenGaesteID->FormattingEnabled = true;
			this->comboBoxBestellungenGaesteID->Location = System::Drawing::Point(192, 42);
			this->comboBoxBestellungenGaesteID->Name = L"comboBoxBestellungenGaesteID";
			this->comboBoxBestellungenGaesteID->Size = System::Drawing::Size(238, 21);
			this->comboBoxBestellungenGaesteID->TabIndex = 2;
			// 
			// checkBoxBestellungenFiltern
			// 
			this->checkBoxBestellungenFiltern->AutoSize = true;
			this->checkBoxBestellungenFiltern->Location = System::Drawing::Point(58, 328);
			this->checkBoxBestellungenFiltern->Name = L"checkBoxBestellungenFiltern";
			this->checkBoxBestellungenFiltern->Size = System::Drawing::Size(54, 17);
			this->checkBoxBestellungenFiltern->TabIndex = 21;
			this->checkBoxBestellungenFiltern->Text = L"Filtern";
			this->checkBoxBestellungenFiltern->UseVisualStyleBackColor = true;
			this->checkBoxBestellungenFiltern->CheckedChanged += gcnew System::EventHandler(this, &FormMain::checkBoxBestellungenFiltern_CheckedChanged);
			// 
			// labelBestellungenMenge
			// 
			this->labelBestellungenMenge->AutoSize = true;
			this->labelBestellungenMenge->Location = System::Drawing::Point(117, 197);
			this->labelBestellungenMenge->Name = L"labelBestellungenMenge";
			this->labelBestellungenMenge->Size = System::Drawing::Size(40, 13);
			this->labelBestellungenMenge->TabIndex = 0;
			this->labelBestellungenMenge->Text = L"Menge";
			// 
			// labelBestellungenDatum
			// 
			this->labelBestellungenDatum->AutoSize = true;
			this->labelBestellungenDatum->Location = System::Drawing::Point(90, 146);
			this->labelBestellungenDatum->Name = L"labelBestellungenDatum";
			this->labelBestellungenDatum->Size = System::Drawing::Size(67, 13);
			this->labelBestellungenDatum->TabIndex = 0;
			this->labelBestellungenDatum->Text = L"Bestelldatum";
			// 
			// dateTimePickerBestellungenDatum
			// 
			this->dateTimePickerBestellungenDatum->DropDownAlign = System::Windows::Forms::LeftRightAlignment::Right;
			this->dateTimePickerBestellungenDatum->Format = System::Windows::Forms::DateTimePickerFormat::Custom;
			this->dateTimePickerBestellungenDatum->Location = System::Drawing::Point(192, 139);
			this->dateTimePickerBestellungenDatum->Name = L"dateTimePickerBestellungenDatum";
			this->dateTimePickerBestellungenDatum->Size = System::Drawing::Size(238, 20);
			this->dateTimePickerBestellungenDatum->TabIndex = 4;
			// 
			// numericUpDownBestellungenMenge
			// 
			this->numericUpDownBestellungenMenge->Location = System::Drawing::Point(192, 190);
			this->numericUpDownBestellungenMenge->Name = L"numericUpDownBestellungenMenge";
			this->numericUpDownBestellungenMenge->Size = System::Drawing::Size(238, 20);
			this->numericUpDownBestellungenMenge->TabIndex = 5;
			this->numericUpDownBestellungenMenge->ValueChanged += gcnew System::EventHandler(this, &FormMain::numericUpDownBestellungenMenge_ValueChanged);
			// 
			// textBoxBestellungenFiltern
			// 
			this->textBoxBestellungenFiltern->Enabled = false;
			this->textBoxBestellungenFiltern->Location = System::Drawing::Point(233, 325);
			this->textBoxBestellungenFiltern->Name = L"textBoxBestellungenFiltern";
			this->textBoxBestellungenFiltern->Size = System::Drawing::Size(197, 20);
			this->textBoxBestellungenFiltern->TabIndex = 22;
			this->textBoxBestellungenFiltern->TextChanged += gcnew System::EventHandler(this, &FormMain::textBoxBestellungenFiltern_TextChanged);
			// 
			// labelBestellungenFiltern
			// 
			this->labelBestellungenFiltern->AutoSize = true;
			this->labelBestellungenFiltern->Location = System::Drawing::Point(171, 332);
			this->labelBestellungenFiltern->Name = L"labelBestellungenFiltern";
			this->labelBestellungenFiltern->Size = System::Drawing::Size(31, 13);
			this->labelBestellungenFiltern->TabIndex = 0;
			this->labelBestellungenFiltern->Text = L"nach";
			// 
			// labelBestellungenGaesteID
			// 
			this->labelBestellungenGaesteID->AutoSize = true;
			this->labelBestellungenGaesteID->Location = System::Drawing::Point(118, 50);
			this->labelBestellungenGaesteID->Name = L"labelBestellungenGaesteID";
			this->labelBestellungenGaesteID->Size = System::Drawing::Size(29, 13);
			this->labelBestellungenGaesteID->TabIndex = 0;
			this->labelBestellungenGaesteID->Text = L"Gast";
			// 
			// labelBestellungenKuchenID
			// 
			this->labelBestellungenKuchenID->AutoSize = true;
			this->labelBestellungenKuchenID->Location = System::Drawing::Point(103, 100);
			this->labelBestellungenKuchenID->Name = L"labelBestellungenKuchenID";
			this->labelBestellungenKuchenID->Size = System::Drawing::Size(44, 13);
			this->labelBestellungenKuchenID->TabIndex = 0;
			this->labelBestellungenKuchenID->Text = L"Kuchen";
			// 
			// buttonBestellungenNeu
			// 
			this->buttonBestellungenNeu->Location = System::Drawing::Point(341, 389);
			this->buttonBestellungenNeu->Name = L"buttonBestellungenNeu";
			this->buttonBestellungenNeu->Size = System::Drawing::Size(89, 48);
			this->buttonBestellungenNeu->TabIndex = 12;
			this->buttonBestellungenNeu->Text = L"Neu";
			this->buttonBestellungenNeu->UseVisualStyleBackColor = true;
			this->buttonBestellungenNeu->Click += gcnew System::EventHandler(this, &FormMain::buttonBestellungenNeu_Click);
			// 
			// buttonBestellungenLoeschen
			// 
			this->buttonBestellungenLoeschen->Enabled = false;
			this->buttonBestellungenLoeschen->Location = System::Drawing::Point(202, 389);
			this->buttonBestellungenLoeschen->Name = L"buttonBestellungenLoeschen";
			this->buttonBestellungenLoeschen->Size = System::Drawing::Size(89, 48);
			this->buttonBestellungenLoeschen->TabIndex = 11;
			this->buttonBestellungenLoeschen->Text = L"Lschen";
			this->buttonBestellungenLoeschen->UseVisualStyleBackColor = true;
			this->buttonBestellungenLoeschen->Click += gcnew System::EventHandler(this, &FormMain::buttonBestellungenLoeschen_Click);
			// 
			// buttonBestellungenSpeichern
			// 
			this->buttonBestellungenSpeichern->Enabled = false;
			this->buttonBestellungenSpeichern->Location = System::Drawing::Point(58, 389);
			this->buttonBestellungenSpeichern->Name = L"buttonBestellungenSpeichern";
			this->buttonBestellungenSpeichern->Size = System::Drawing::Size(89, 48);
			this->buttonBestellungenSpeichern->TabIndex = 10;
			this->buttonBestellungenSpeichern->Text = L"Speichern";
			this->buttonBestellungenSpeichern->UseVisualStyleBackColor = true;
			this->buttonBestellungenSpeichern->Click += gcnew System::EventHandler(this, &FormMain::buttonBestellungenSpeichern_Click);
			// 
			// tabPageKuchen
			// 
			this->tabPageKuchen->Controls->Add(this->splitContainerKuchen);
			this->tabPageKuchen->Location = System::Drawing::Point(4, 22);
			this->tabPageKuchen->Name = L"tabPageKuchen";
			this->tabPageKuchen->Padding = System::Windows::Forms::Padding(3);
			this->tabPageKuchen->Size = System::Drawing::Size(1212, 480);
			this->tabPageKuchen->TabIndex = 0;
			this->tabPageKuchen->Text = L"Kuchen";
			this->tabPageKuchen->UseVisualStyleBackColor = true;
			// 
			// splitContainerKuchen
			// 
			this->splitContainerKuchen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitContainerKuchen->Location = System::Drawing::Point(3, 3);
			this->splitContainerKuchen->Name = L"splitContainerKuchen";
			// 
			// splitContainerKuchen.Panel1
			// 
			this->splitContainerKuchen->Panel1->Controls->Add(this->dataGridViewKuchen);
			// 
			// splitContainerKuchen.Panel2
			// 
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenBestellt);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenBestellt);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenPreis);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenPreis);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenKurzName);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenKurzName);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenDiabetikergeeignet);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenDiabetikergeeignet);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenAnzahl);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenAbgabedatum);
			this->splitContainerKuchen->Panel2->Controls->Add(this->checkBoxKuchenFiltern);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenAnzahl);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenAbgabedatum);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenFiltern);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenFilter);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenAnbieter);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenSorte);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenBeschreibung);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenAnbieter);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenSorte);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenBeschreibung);
			this->splitContainerKuchen->Panel2->Controls->Add(this->buttonKuchenNeu);
			this->splitContainerKuchen->Panel2->Controls->Add(this->buttonKuchenLoeschen);
			this->splitContainerKuchen->Panel2->Controls->Add(this->buttonKuchenAendern);
			this->splitContainerKuchen->Size = System::Drawing::Size(1206, 474);
			this->splitContainerKuchen->SplitterDistance = 648;
			this->splitContainerKuchen->TabIndex = 0;
			// 
			// dataGridViewKuchen
			// 
			this->dataGridViewKuchen->AllowUserToAddRows = false;
			this->dataGridViewKuchen->AllowUserToDeleteRows = false;
			this->dataGridViewKuchen->AutoSizeColumnsMode = System::Windows::Forms::DataGridViewAutoSizeColumnsMode::Fill;
			this->dataGridViewKuchen->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewKuchen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->dataGridViewKuchen->Location = System::Drawing::Point(0, 0);
			this->dataGridViewKuchen->Name = L"dataGridViewKuchen";
			this->dataGridViewKuchen->ReadOnly = true;
			this->dataGridViewKuchen->SelectionMode = System::Windows::Forms::DataGridViewSelectionMode::FullRowSelect;
			this->dataGridViewKuchen->Size = System::Drawing::Size(648, 474);
			this->dataGridViewKuchen->TabIndex = 0;
			this->dataGridViewKuchen->SelectionChanged += gcnew System::EventHandler(this, &FormMain::selectKuchenElement_Click);
			// 
			// labelKuchenBestellt
			// 
			this->labelKuchenBestellt->AutoSize = true;
			this->labelKuchenBestellt->Location = System::Drawing::Point(52, 240);
			this->labelKuchenBestellt->Name = L"labelKuchenBestellt";
			this->labelKuchenBestellt->Size = System::Drawing::Size(97, 13);
			this->labelKuchenBestellt->TabIndex = 33;
			this->labelKuchenBestellt->Text = L"Bereits Abgegeben";
			// 
			// textBoxKuchenBestellt
			// 
			this->textBoxKuchenBestellt->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenBestellt->Location = System::Drawing::Point(192, 233);
			this->textBoxKuchenBestellt->Name = L"textBoxKuchenBestellt";
			this->textBoxKuchenBestellt->ReadOnly = true;
			this->textBoxKuchenBestellt->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenBestellt->TabIndex = 32;
			// 
			// labelKuchenPreis
			// 
			this->labelKuchenPreis->AutoSize = true;
			this->labelKuchenPreis->Location = System::Drawing::Point(119, 269);
			this->labelKuchenPreis->Name = L"labelKuchenPreis";
			this->labelKuchenPreis->Size = System::Drawing::Size(30, 13);
			this->labelKuchenPreis->TabIndex = 31;
			this->labelKuchenPreis->Text = L"Preis";
			// 
			// textBoxKuchenPreis
			// 
			this->textBoxKuchenPreis->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenPreis->Location = System::Drawing::Point(192, 262);
			this->textBoxKuchenPreis->Name = L"textBoxKuchenPreis";
			this->textBoxKuchenPreis->ReadOnly = true;
			this->textBoxKuchenPreis->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenPreis->TabIndex = 30;
			// 
			// labelKuchenKurzName
			// 
			this->labelKuchenKurzName->AutoSize = true;
			this->labelKuchenKurzName->Location = System::Drawing::Point(95, 98);
			this->labelKuchenKurzName->Name = L"labelKuchenKurzName";
			this->labelKuchenKurzName->Size = System::Drawing::Size(54, 13);
			this->labelKuchenKurzName->TabIndex = 28;
			this->labelKuchenKurzName->Text = L"Kurzname";
			// 
			// textBoxKuchenKurzName
			// 
			this->textBoxKuchenKurzName->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenKurzName->Location = System::Drawing::Point(192, 91);
			this->textBoxKuchenKurzName->Name = L"textBoxKuchenKurzName";
			this->textBoxKuchenKurzName->ReadOnly = true;
			this->textBoxKuchenKurzName->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenKurzName->TabIndex = 27;
			// 
			// textBoxKuchenDiabetikergeeignet
			// 
			this->textBoxKuchenDiabetikergeeignet->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenDiabetikergeeignet->Location = System::Drawing::Point(192, 294);
			this->textBoxKuchenDiabetikergeeignet->Name = L"textBoxKuchenDiabetikergeeignet";
			this->textBoxKuchenDiabetikergeeignet->ReadOnly = true;
			this->textBoxKuchenDiabetikergeeignet->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenDiabetikergeeignet->TabIndex = 26;
			// 
			// labelKuchenDiabetikergeeignet
			// 
			this->labelKuchenDiabetikergeeignet->AutoSize = true;
			this->labelKuchenDiabetikergeeignet->Location = System::Drawing::Point(33, 301);
			this->labelKuchenDiabetikergeeignet->Name = L"labelKuchenDiabetikergeeignet";
			this->labelKuchenDiabetikergeeignet->Size = System::Drawing::Size(117, 13);
			this->labelKuchenDiabetikergeeignet->TabIndex = 25;
			this->labelKuchenDiabetikergeeignet->Text = L"Fr Diabetiker geeignet";
			// 
			// textBoxKuchenAnzahl
			// 
			this->textBoxKuchenAnzahl->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenAnzahl->Location = System::Drawing::Point(192, 196);
			this->textBoxKuchenAnzahl->Name = L"textBoxKuchenAnzahl";
			this->textBoxKuchenAnzahl->ReadOnly = true;
			this->textBoxKuchenAnzahl->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenAnzahl->TabIndex = 23;
			// 
			// textBoxKuchenAbgabedatum
			// 
			this->textBoxKuchenAbgabedatum->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenAbgabedatum->Location = System::Drawing::Point(192, 158);
			this->textBoxKuchenAbgabedatum->Name = L"textBoxKuchenAbgabedatum";
			this->textBoxKuchenAbgabedatum->ReadOnly = true;
			this->textBoxKuchenAbgabedatum->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenAbgabedatum->TabIndex = 22;
			// 
			// checkBoxKuchenFiltern
			// 
			this->checkBoxKuchenFiltern->AutoSize = true;
			this->checkBoxKuchenFiltern->Location = System::Drawing::Point(83, 339);
			this->checkBoxKuchenFiltern->Name = L"checkBoxKuchenFiltern";
			this->checkBoxKuchenFiltern->Size = System::Drawing::Size(54, 17);
			this->checkBoxKuchenFiltern->TabIndex = 21;
			this->checkBoxKuchenFiltern->Text = L"Filtern";
			this->checkBoxKuchenFiltern->UseVisualStyleBackColor = true;
			this->checkBoxKuchenFiltern->CheckedChanged += gcnew System::EventHandler(this, &FormMain::checkBoxKuchenFiltern_CheckedChanged);
			// 
			// labelKuchenAnzahl
			// 
			this->labelKuchenAnzahl->AutoSize = true;
			this->labelKuchenAnzahl->Location = System::Drawing::Point(68, 203);
			this->labelKuchenAnzahl->Name = L"labelKuchenAnzahl";
			this->labelKuchenAnzahl->Size = System::Drawing::Size(82, 13);
			this->labelKuchenAnzahl->TabIndex = 20;
			this->labelKuchenAnzahl->Text = L"Noch Verfgbar";
			// 
			// labelKuchenAbgabedatum
			// 
			this->labelKuchenAbgabedatum->AutoSize = true;
			this->labelKuchenAbgabedatum->Location = System::Drawing::Point(77, 165);
			this->labelKuchenAbgabedatum->Name = L"labelKuchenAbgabedatum";
			this->labelKuchenAbgabedatum->Size = System::Drawing::Size(73, 13);
			this->labelKuchenAbgabedatum->TabIndex = 19;
			this->labelKuchenAbgabedatum->Text = L"Abgabedatum";
			// 
			// textBoxKuchenFiltern
			// 
			this->textBoxKuchenFiltern->Enabled = false;
			this->textBoxKuchenFiltern->Location = System::Drawing::Point(233, 332);
			this->textBoxKuchenFiltern->Name = L"textBoxKuchenFiltern";
			this->textBoxKuchenFiltern->Size = System::Drawing::Size(197, 20);
			this->textBoxKuchenFiltern->TabIndex = 16;
			this->textBoxKuchenFiltern->TextChanged += gcnew System::EventHandler(this, &FormMain::textBoxKuchenFiltern_TextChanged);
			// 
			// labelKuchenFilter
			// 
			this->labelKuchenFilter->AutoSize = true;
			this->labelKuchenFilter->Location = System::Drawing::Point(172, 339);
			this->labelKuchenFilter->Name = L"labelKuchenFilter";
			this->labelKuchenFilter->Size = System::Drawing::Size(31, 13);
			this->labelKuchenFilter->TabIndex = 14;
			this->labelKuchenFilter->Text = L"nach";
			// 
			// textBoxKuchenAnbieter
			// 
			this->textBoxKuchenAnbieter->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenAnbieter->Location = System::Drawing::Point(192, 26);
			this->textBoxKuchenAnbieter->Name = L"textBoxKuchenAnbieter";
			this->textBoxKuchenAnbieter->ReadOnly = true;
			this->textBoxKuchenAnbieter->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenAnbieter->TabIndex = 2;
			// 
			// textBoxKuchenSorte
			// 
			this->textBoxKuchenSorte->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenSorte->Location = System::Drawing::Point(192, 61);
			this->textBoxKuchenSorte->Name = L"textBoxKuchenSorte";
			this->textBoxKuchenSorte->ReadOnly = true;
			this->textBoxKuchenSorte->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenSorte->TabIndex = 3;
			// 
			// textBoxKuchenBeschreibung
			// 
			this->textBoxKuchenBeschreibung->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenBeschreibung->Location = System::Drawing::Point(192, 126);
			this->textBoxKuchenBeschreibung->Name = L"textBoxKuchenBeschreibung";
			this->textBoxKuchenBeschreibung->ReadOnly = true;
			this->textBoxKuchenBeschreibung->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenBeschreibung->TabIndex = 4;
			// 
			// labelKuchenAnbieter
			// 
			this->labelKuchenAnbieter->AutoSize = true;
			this->labelKuchenAnbieter->Location = System::Drawing::Point(103, 33);
			this->labelKuchenAnbieter->Name = L"labelKuchenAnbieter";
			this->labelKuchenAnbieter->Size = System::Drawing::Size(46, 13);
			this->labelKuchenAnbieter->TabIndex = 0;
			this->labelKuchenAnbieter->Text = L"Anbieter";
			// 
			// labelKuchenSorte
			// 
			this->labelKuchenSorte->AutoSize = true;
			this->labelKuchenSorte->Location = System::Drawing::Point(117, 68);
			this->labelKuchenSorte->Name = L"labelKuchenSorte";
			this->labelKuchenSorte->Size = System::Drawing::Size(32, 13);
			this->labelKuchenSorte->TabIndex = 0;
			this->labelKuchenSorte->Text = L"Sorte";
			// 
			// labelKuchenBeschreibung
			// 
			this->labelKuchenBeschreibung->AutoSize = true;
			this->labelKuchenBeschreibung->Location = System::Drawing::Point(77, 133);
			this->labelKuchenBeschreibung->Name = L"labelKuchenBeschreibung";
			this->labelKuchenBeschreibung->Size = System::Drawing::Size(72, 13);
			this->labelKuchenBeschreibung->TabIndex = 0;
			this->labelKuchenBeschreibung->Text = L"Beschreibung";
			// 
			// buttonKuchenNeu
			// 
			this->buttonKuchenNeu->Location = System::Drawing::Point(341, 389);
			this->buttonKuchenNeu->Name = L"buttonKuchenNeu";
			this->buttonKuchenNeu->Size = System::Drawing::Size(89, 48);
			this->buttonKuchenNeu->TabIndex = 12;
			this->buttonKuchenNeu->Text = L"Neu";
			this->buttonKuchenNeu->UseVisualStyleBackColor = true;
			this->buttonKuchenNeu->Click += gcnew System::EventHandler(this, &FormMain::buttonKuchenNeu_Click);
			// 
			// buttonKuchenLoeschen
			// 
			this->buttonKuchenLoeschen->Enabled = false;
			this->buttonKuchenLoeschen->Location = System::Drawing::Point(202, 389);
			this->buttonKuchenLoeschen->Name = L"buttonKuchenLoeschen";
			this->buttonKuchenLoeschen->Size = System::Drawing::Size(89, 48);
			this->buttonKuchenLoeschen->TabIndex = 11;
			this->buttonKuchenLoeschen->Text = L"Lschen";
			this->buttonKuchenLoeschen->UseVisualStyleBackColor = true;
			this->buttonKuchenLoeschen->Click += gcnew System::EventHandler(this, &FormMain::buttonKuchenLoeschen_Click);
			// 
			// buttonKuchenAendern
			// 
			this->buttonKuchenAendern->Enabled = false;
			this->buttonKuchenAendern->Location = System::Drawing::Point(58, 389);
			this->buttonKuchenAendern->Name = L"buttonKuchenAendern";
			this->buttonKuchenAendern->Size = System::Drawing::Size(89, 48);
			this->buttonKuchenAendern->TabIndex = 10;
			this->buttonKuchenAendern->Text = L"ndern";
			this->buttonKuchenAendern->UseVisualStyleBackColor = true;
			this->buttonKuchenAendern->Click += gcnew System::EventHandler(this, &FormMain::buttonKuchenAendern_Click);
			// 
			// tabPageGaeste
			// 
			this->tabPageGaeste->Controls->Add(this->splitContainerGaeste);
			this->tabPageGaeste->Location = System::Drawing::Point(4, 22);
			this->tabPageGaeste->Name = L"tabPageGaeste";
			this->tabPageGaeste->Padding = System::Windows::Forms::Padding(3);
			this->tabPageGaeste->Size = System::Drawing::Size(1212, 480);
			this->tabPageGaeste->TabIndex = 0;
			this->tabPageGaeste->Text = L"Gste";
			this->tabPageGaeste->UseVisualStyleBackColor = true;
			// 
			// FormMain
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::SystemColors::Window;
			this->BackgroundImageLayout = System::Windows::Forms::ImageLayout::None;
			this->ClientSize = System::Drawing::Size(1220, 530);
			this->Controls->Add(this->tabControl1);
			this->Controls->Add(this->menuStrip1);
			this->MainMenuStrip = this->menuStrip1;
			this->Name = L"FormMain";
			this->Text = L"Kuchen Basar";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &FormMain::FormMain_FormClosing);
			this->splitContainerGaeste->Panel1->ResumeLayout(false);
			this->splitContainerGaeste->Panel2->ResumeLayout(false);
			this->splitContainerGaeste->Panel2->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerGaeste))->EndInit();
			this->splitContainerGaeste->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewGaeste))->EndInit();
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->tabControl1->ResumeLayout(false);
			this->tabPageBestellungen->ResumeLayout(false);
			this->splitContainerBestellungen->Panel1->ResumeLayout(false);
			this->splitContainerBestellungen->Panel2->ResumeLayout(false);
			this->splitContainerBestellungen->Panel2->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerBestellungen))->EndInit();
			this->splitContainerBestellungen->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewBestellungen))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numericUpDownBestellungenPreis))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numericUpDownBestellungenMenge))->EndInit();
			this->tabPageKuchen->ResumeLayout(false);
			this->splitContainerKuchen->Panel1->ResumeLayout(false);
			this->splitContainerKuchen->Panel2->ResumeLayout(false);
			this->splitContainerKuchen->Panel2->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerKuchen))->EndInit();
			this->splitContainerKuchen->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewKuchen))->EndInit();
			this->tabPageGaeste->ResumeLayout(false);
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private:
		int bestimmeDataGridViewZeile(DataGridView^ aktDataGridView, int aktID)
		{
			Object^ tempObjID;
			int tempID;

			//aktID == 0 heit, es ist keine ID aktiv, soll aber die erste aktiviert werden
			if (aktID == 0)
			{
				return 0;
			}

			//aktID == -1 heit, es ist keine ID aktiv, soll aber die letzte aktiviert werden
			int anzahl = aktDataGridView->Rows->Count;

			if (aktID < 0)
			{
				return anzahl - 1;
			}

			//Suche die Zeile, wo die ID drin steht
			for (int i = 0; i < anzahl; i++)
			{
				tempObjID = aktDataGridView->Rows[i]->Cells["ID"]->Value;
				if (tempObjID != nullptr)
				{
					tempID = Convert::ToInt32(tempObjID->ToString());
					if (tempID == aktID)
					{
						return i;
					}
				}
			}

			//nicht gefunden -> erste Zeile
			return 0;
		}

		int bestimmeDataGridViewIndex(DataGridView^ aktDataGridView)
		{
			int tempID = 0;
			Object^ tempObjID = aktDataGridView->SelectedRows[0]->Cells["ID"]->Value;
			if (tempObjID != nullptr)
			{
				tempID = Convert::ToInt32(tempObjID->ToString());
			}
			
			return tempID;
		}
	
		//Bestellungen
		Void refreshBestellungenDaten()
		{
			int retteMich = aktBestellungenID;

			if (checkBoxBestellungenFiltern->Checked)
			{
				String^ suchmaske = textBoxBestellungenFiltern->Text;
				dataGridViewBestellungen->DataSource = dbAssistent->getBestellungenTabelle(suchmaske);
			}
			else
			{
				dataGridViewBestellungen->DataSource = dbAssistent->getBestellungenTabelle();
			}

			dataGridViewBestellungen->Columns["ID"]->Visible = false;

			aktBestellungenID = retteMich;

			int aktZeile = bestimmeDataGridViewZeile(dataGridViewBestellungen, aktBestellungenID);

			if (dataGridViewBestellungen->RowCount > 0)
			{
				//da Cells[0] = ID unsichtbar ist, nehmen wir die nchste
				dataGridViewBestellungen->CurrentCell = dataGridViewBestellungen->Rows[aktZeile]->Cells[1];
			}
			else
			{
				schliessenBestellungenBoxen();
			}
		}

		Void oeffnenBestellungenBoxen()
		{
			comboBoxBestellungenGaesteID->Enabled = true;
			comboBoxBestellungenKuchenID->Enabled = true;
			numericUpDownBestellungenMenge->ReadOnly = false;
			numericUpDownBestellungenPreis->ReadOnly = false;
			dateTimePickerBestellungenDatum->Enabled = true;
			checkBoxBestellungenBezahlt->Enabled = true;
			checkBoxBestellungenGeliefert->Enabled = true;

			buttonBestellungenSpeichern->Enabled = true;
			buttonBestellungenLoeschen->Enabled = true;
		}

		Void schliessenBestellungenBoxen()
		{
			comboBoxBestellungenGaesteID->SelectedIndex = 0;
			comboBoxBestellungenKuchenID->SelectedIndex = 0;
			numericUpDownBestellungenMenge->Value = 0;
			numericUpDownBestellungenPreis->Value = 0;
			dateTimePickerBestellungenDatum->Value = DateTime(2000, 1, 1);
			checkBoxBestellungenBezahlt->Checked = false;
			checkBoxBestellungenGeliefert->Checked = false;

			comboBoxBestellungenGaesteID->Enabled = false;
			comboBoxBestellungenKuchenID->Enabled = false;
			numericUpDownBestellungenMenge->ReadOnly = true;
			numericUpDownBestellungenPreis->ReadOnly = true;
			dateTimePickerBestellungenDatum->Enabled = false;
			checkBoxBestellungenBezahlt->Enabled = false;
			checkBoxBestellungenGeliefert->Enabled = false;

			buttonBestellungenSpeichern->Enabled = false;
			buttonBestellungenLoeschen->Enabled = false;
		}

		Void selectBestellungenElement_Click(Object^  sender, EventArgs^  e)
		{
			if (dataGridViewBestellungen->SelectedRows->Count > 0)
			{
				aktBestellungenID = bestimmeDataGridViewIndex(dataGridViewBestellungen);

				Bestellung^ tempBestellung = dbAssistent->getBestellung(aktBestellungenID);
				if (tempBestellung != nullptr)
				{
					if (dbAssistent->changedKuchenList())
					{
						//Die Liste kann sich ndern, die Combobox bekommt das aber sonst nicht mit
						comboBoxBestellungenKuchenID->DataSource = nullptr;
						comboBoxBestellungenKuchenID->DataSource = dbAssistent->getKuchenList();
					}

					//Wenn die KuchenListe aktuell ist, ist (jetzt erst) auch das Dictionary aktuell
					//Da im Key(ID) der Access Datenbank wegen des Autowertes Lcken sein knnen,
					//beim Index der Combobox aber natrlich nicht, wird das hier und in der Speichern-Methode
					//repariert (umgesetzt durch eben zwei spiegelbildlichen Dictionary)

					int tempKuchenID = tempBestellung->KuchenId;
					int tempKuchenIndex = dbAssistent->IndexFromIdKuchen(tempKuchenID);

					if (comboBoxBestellungenKuchenID->SelectedIndex != tempKuchenIndex)
					{
						comboBoxBestellungenKuchenID->SelectedIndex = tempKuchenIndex;
					}

					if (dbAssistent->changedGaesteList())
					{
						//Die Liste kann sich ndern, die Combobox bekommt das aber sonst nicht mit
						comboBoxBestellungenGaesteID->DataSource = nullptr;
						comboBoxBestellungenGaesteID->DataSource = dbAssistent->getGaesteList();
					}
		
					//Da auch im Key(ID) der Gaeste Lcken sein knnen,
					//gilt hier das gleiche Verfahren mit der Umsetzung ID->Index
					
					int tempGaesteID = tempBestellung->GaesteId;
					int tempGaesteIndex = dbAssistent->IndexFromIdGaeste(tempGaesteID);

					if (comboBoxBestellungenGaesteID->SelectedIndex != tempGaesteIndex)
					{
						comboBoxBestellungenGaesteID->SelectedIndex = tempGaesteIndex;
					}

					dateTimePickerBestellungenDatum->CustomFormat = "dd.MMM.yyyy, HH:mm:ss";
					dateTimePickerBestellungenDatum->Text = tempBestellung->Bestelldatum->ToString();

					//Lese erstmal aus der Bestellung, setze die Box zurck von eventuell anderen Kuchen
					numericUpDownBestellungenMenge->Maximum = 10000000;
					numericUpDownBestellungenMenge->Value = Convert::ToInt32(tempBestellung->Menge);
		
					//aktualisiere ggf. mit dem Vorrat, kein Kuchenwechsel
					setzeBestellungenMenge(tempKuchenID, false);

					numericUpDownBestellungenPreis->Value = Convert::ToDecimal(tempBestellung->Gesamtpreis);

					checkBoxBestellungenBezahlt->Checked = tempBestellung->Bezahlt;
					checkBoxBestellungenGeliefert->Checked = tempBestellung->Geliefert;
				}

				oeffnenBestellungenBoxen();
			}
		}

		bool komplexePlausisBestellungen()
		{
			if (comboBoxBestellungenGaesteID->SelectedIndex == 0)
			{
				MessageBox::Show("kein gltiger Gast");
				return false;
			}
	
			if (comboBoxBestellungenKuchenID->SelectedIndex == 0)
			{
				MessageBox::Show("kein gltiger Kuchen");
				return false;
			}

			if (numericUpDownBestellungenMenge->Value == 0)
			{
				MessageBox::Show("Menge darf nicht 0 sein");
				return false;
			}

			if (numericUpDownBestellungenMenge->Value > numericUpDownBestellungenMenge->Maximum)
			{
				MessageBox::Show("Es sind nur noch " + numericUpDownBestellungenMenge->Maximum + " Stcke da");
				return false;
			}

			if (Convert::ToDouble(numericUpDownBestellungenPreis->Value) < 0.1)
			{
				MessageBox::Show("Preis darf nicht 0.00 sein");
				return false;
			}

			return true;
		}

		void setzeBestellungenMenge(int kuchenID, bool isKuchenWechsel)
		{
			int vorrat = dbAssistent->getVorratKuchen(kuchenID);
			int bisher = Convert::ToInt32(numericUpDownBestellungenMenge->Value);

			//es sind soviele mglich, wie vorrtig sind vom neuen oder gleichen Kuchen.
			int moeglich = vorrat;

			//plus, soviele wie wir jetzt schon haben, wenn der Kuchen gleich bleibt
			//(das Ausgleichen bercksichtigt das dann)
			if (! isKuchenWechsel)
			{
				moeglich = vorrat + bisher;
			}

			//der neue Kuchen erlaubt die Menge nicht
			if (bisher > moeglich)
			{
				bisher = moeglich;
			}

			//Setzen der aktuellen Werte, die auf jeden Fall gltig sind 
			//Damit die ComboBox nicht platzt, erst das Maximum, dann den Wert
			numericUpDownBestellungenMenge->Maximum = moeglich;
			numericUpDownBestellungenMenge->Value = bisher;
		}

		Void comboBoxBestellungenKuchenID_SelectedIndexChanged(Object^  sender, EventArgs^  e)
		{
			if (comboBoxBestellungenKuchenID->SelectedIndex > 0)
			{
				int tempIndex = comboBoxBestellungenKuchenID->SelectedIndex;
				int tempID = dbAssistent->IdFromIndexKuchen(tempIndex);

				setzeBestellungenMenge(tempID, true);

				double preis = dbAssistent->getPreisKuchen(tempID);
				int anzahl = Convert::ToInt32(numericUpDownBestellungenMenge->Value);

				numericUpDownBestellungenPreis->Value = Convert::ToDecimal(anzahl * preis);
			}
		}

		Void numericUpDownBestellungenMenge_ValueChanged(Object^  sender, EventArgs^  e)
		{
			int tempIndex = comboBoxBestellungenKuchenID->SelectedIndex;
			int tempID = dbAssistent->IdFromIndexKuchen(tempIndex);

			int anzahl = Convert::ToInt32(numericUpDownBestellungenMenge->Value);
			double preis = dbAssistent->getPreisKuchen(tempID);

			numericUpDownBestellungenPreis->Value = Convert::ToDecimal(anzahl * preis);
		}

		Void buttonBestellungenSpeichern_Click(Object^  sender, EventArgs^  e)
		{
			if (!komplexePlausisBestellungen())
			{
				//MessageBox::Show("mind. ein Wert war nicht korrekt");
			}
			else
			{
				aktBestellungenID = bestimmeDataGridViewIndex(dataGridViewBestellungen);

				Bestellung^ aktBestellung = dbAssistent->getBestellung(aktBestellungenID);

				int tempKuchenIndex = comboBoxBestellungenKuchenID->SelectedIndex;
				int tempKuchenID = dbAssistent->IdFromIndexKuchen(tempKuchenIndex);

				int tempAlterKuchenID = aktBestellung->KuchenId;
				int tempAlterKuchenMenge = aktBestellung->Menge;

				aktBestellung->KuchenId = tempKuchenID;

				int tempGaesteIndex = comboBoxBestellungenGaesteID->SelectedIndex;
				int tempGaesteID = dbAssistent->IdFromIndexGaeste(tempGaesteIndex);

				aktBestellung->GaesteId = tempGaesteID;

				//wieder Entfernen des Custom Format Kommas
				String^ tempDatum = dateTimePickerBestellungenDatum->Text->Replace(',', ' ');
				aktBestellung->Bestelldatum = Convert::ToDateTime(tempDatum);

				aktBestellung->Menge = Convert::ToInt32(numericUpDownBestellungenMenge->Value);
				aktBestellung->Gesamtpreis = Convert::ToDouble(numericUpDownBestellungenPreis->Value);

				aktBestellung->Bezahlt = checkBoxBestellungenBezahlt->Checked;
				aktBestellung->Geliefert = checkBoxBestellungenGeliefert->Checked;

				//Der dbAssistent ruft hier neben dem Update auf die Bestellungen
				//intern noch die Aktualisierung der Vorratsmenge beim Kuchen auf!
				//Da mir aber fr eine komplexe Umbuchung von altem Kuchen auf neuen Kuchen 
				//mit Trigger, in Access etwas die Ideen fehlen, habe ich auch aus Zeitgrnden
				//die etwas komisch aussehende Steuerung ber die FormMain akzeptiert 
				//dbAssistent->updateBestellung(aktBestellung);
				dbAssistent->updateBestellung(aktBestellung, tempAlterKuchenID, tempAlterKuchenMenge);

				refreshBestellungenDaten();
			}
		}

		Void buttonBestellungenLoeschen_Click(Object^  sender, EventArgs^  e)
		{
			aktBestellungenID = bestimmeDataGridViewIndex(dataGridViewBestellungen);

			dbAssistent->deleteBestellung(aktBestellungenID);

			aktBestellungenID = 0;

			refreshBestellungenDaten();
		}

		Void buttonBestellungenNeu_Click(Object^  sender, EventArgs^  e)
		{
			//Access zhlt Autowerte standardmig ab 1, C++ hat als Indexbeginn 0
			//Beides scheint irgendwie sinnvoll
			//Um die Zusammenarbeit zu vereinfachen, wurden in den Basistabellen Zeilen mit Index 0
			//angelegt, die jedoch nur technische Inhalte haben und nicht angezeigt werden
			Bestellung^ aktBestellung = gcnew Bestellung(-1, 0, 0, DateTime::Now, 0, 0.0, false, false);

			//Der dbAssistent ruft neben dem Insert auf die Bestellungen
			//intern noch die Aktualisierung der Vorratsmenge beim Kuchen auf!
			aktBestellungenID = dbAssistent->insertBestellung(aktBestellung);

			//das mu leider sein, weil sonst neue Stze verloren gehen
			checkBoxBestellungenFiltern->Checked = false;
			AktBestellungenID = -1;
	
			refreshBestellungenDaten();
		}

		Void checkBoxBestellungenFiltern_CheckedChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktBestellungenID = 0;

			if (checkBoxBestellungenFiltern->Checked)
			{
				textBoxBestellungenFiltern->Enabled = true;
			}
			else
			{
				textBoxBestellungenFiltern->Enabled = false;
			}

			refreshBestellungenDaten();
		}

		Void textBoxBestellungenFiltern_TextChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktBestellungenID = 0;

			if (textBoxBestellungenFiltern->Text->Length == 0)
			{
				checkBoxBestellungenFiltern->Checked = false;
			}

			refreshBestellungenDaten();
		}

		//Kuchen
		Void refreshKuchenDaten()
		{
			//int berndK1 = aktKuchenID;
			//int berndG1 = aktGaesteID;

			int retteMich = aktKuchenID;

			if (checkBoxKuchenFiltern->Checked)
			{
				String^ suchmaske = textBoxKuchenFiltern->Text;
				dataGridViewKuchen->DataSource = dbAssistent->getKuchenTabelle(suchmaske);
			}
			else
			{
				dataGridViewKuchen->DataSource = dbAssistent->getKuchenTabelle();
			}

			dataGridViewKuchen->Columns["ID"]->Visible = false;

			//nach Lschen/Speichern/Neu soll mglichst auf dem aktuellen Satz positioniert sein
			//nach Lschen: am besten der erste
			//nach Neu: der letzte
			//nach Speichern: die gleiche ID
			//wegen des Filters ist aber erst jetzt klar, welche Zeile das sein kann...

			//ich habe keine Erklrung dafr, aber die aktGaesteID geht hier kapputt??? 
			//mglicherweise berschreibt das DataSource der dataGridView 
			//beim Modulwechsel die einfachen Variablen
			//int berndK2 = aktKuchenID;
			//int berndG2 = aktGaesteID;

			aktKuchenID = retteMich;

			int aktZeile = bestimmeDataGridViewZeile(dataGridViewKuchen, aktKuchenID);

			if (dataGridViewKuchen->RowCount > 0)
			{
				//da Cells[0] = ID unsichtbar ist, nehmen wir die nchste
				dataGridViewKuchen->CurrentCell = dataGridViewKuchen->Rows[aktZeile]->Cells[1];
			}
			else
			{
				schliessenKuchenBoxen();
			}
		}

		Void oeffnenKuchenBoxen()
		{
			buttonKuchenAendern->Enabled = true;
			buttonKuchenLoeschen->Enabled = true;
		}

		Void schliessenKuchenBoxen()
		{
			textBoxKuchenAnbieter->Clear();
			textBoxKuchenSorte->Clear();
			textBoxKuchenKurzName->Clear();
			textBoxKuchenBeschreibung->Clear();
			textBoxKuchenAbgabedatum->Clear();
			textBoxKuchenAnzahl->Clear();
			textBoxKuchenPreis->Clear();
			textBoxKuchenBestellt->Clear();
			textBoxKuchenDiabetikergeeignet->Clear();

			buttonKuchenAendern->Enabled = false;
			buttonKuchenLoeschen->Enabled = false;
		}

		Void selectKuchenElement_Click(Object^  sender, EventArgs^  e)
		{
			if (dataGridViewKuchen->SelectedRows->Count > 0)
			{
				aktKuchenID = bestimmeDataGridViewIndex(dataGridViewKuchen);

				Kuchen^ tempKuchen = dbAssistent->getKuchen(aktKuchenID);
				if (tempKuchen != nullptr)
				{
					textBoxKuchenAnbieter->Text = tempKuchen->Anbieter;
					textBoxKuchenSorte->Text = dbAssistent->getSorte(aktKuchenID);
					textBoxKuchenKurzName->Text = tempKuchen->Kurzkuchen;
					textBoxKuchenBeschreibung->Text = tempKuchen->Beschreibung;
					textBoxKuchenAbgabedatum->Text = tempKuchen->Abgabedatum->ToString();
					textBoxKuchenAnzahl->Text = tempKuchen->Anzahl.ToString();
					textBoxKuchenBestellt->Text = Convert::ToString(dbAssistent->getKuchenBestellungenGesamt(AktKuchenID));
					textBoxKuchenPreis->Text = String::Format("{0:F2}", tempKuchen->Preis) + " ";
					if (tempKuchen->Diabetikergeeignet)
					{
						textBoxKuchenDiabetikergeeignet->Text = "Ja";
					}
					else
					{
						textBoxKuchenDiabetikergeeignet->Text = "Nein";
					}
				}

				oeffnenKuchenBoxen();
			}
		}

		Void buttonKuchenAendern_Click(Object^  sender, EventArgs^  e)
		{
			aktKuchenID = bestimmeDataGridViewIndex(dataGridViewKuchen);

			KuchenWerte^ kuchenAendern = gcnew KuchenWerte(this, dbAssistent);
			kuchenAendern->ShowDialog();

			refreshKuchenDaten();
		}

		Void buttonKuchenLoeschen_Click(Object^  sender, EventArgs^  e)
		{
			aktKuchenID = bestimmeDataGridViewIndex(dataGridViewKuchen);

			dbAssistent->deleteKuchen(aktKuchenID);

			aktKuchenID = 0;

			refreshKuchenDaten();

			//Lschen von Kuchen knnte Auswirkungen auf bereits bestehende Bestellungen haben
			aktBestellungenID = 0;

			refreshBestellungenDaten();
		}

		Void buttonKuchenNeu_Click(Object^  sender, EventArgs^  e)
		{
			//aktKuchenID = -1 heit, da die KuchenWerte Form einen neuen Kuchen anlegen soll
			aktKuchenID = -1;

			KuchenWerte^ kuchenNeu = gcnew KuchenWerte(this, dbAssistent);
			kuchenNeu->ShowDialog();

			//das mu leider sein, weil sonst neue Stze verloren gehen
			checkBoxKuchenFiltern->Checked = false;

			refreshKuchenDaten();
		}

		Void checkBoxKuchenFiltern_CheckedChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktKuchenID = 0;

			if (checkBoxKuchenFiltern->Checked)
			{
				textBoxKuchenFiltern->Enabled = true;
			}
			else
			{
				textBoxKuchenFiltern->Enabled = false;
			}

			refreshKuchenDaten();
		}

		Void textBoxKuchenFiltern_TextChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktKuchenID = 0;

			if (textBoxKuchenFiltern->Text->Length == 0)
			{
				checkBoxKuchenFiltern->Checked = false;
			}

			refreshKuchenDaten();
		}

		//Gaeste
		Void refreshGaesteDaten()
		{
			int retteMich = aktGaesteID;

			if (checkBoxGaesteFiltern->Checked)
			{
				String^ suchmaske = textBoxGaesteFiltern->Text;
				dataGridViewGaeste->DataSource = dbAssistent->getGaesteTabelle(suchmaske);
			}
			else
			{
				dataGridViewGaeste->DataSource = dbAssistent->getGaesteTabelle();
			}

			dataGridViewGaeste->Columns["ID"]->Visible = false;

			aktGaesteID = retteMich;

			int aktZeile = bestimmeDataGridViewZeile(dataGridViewGaeste, aktGaesteID);

			if (dataGridViewGaeste->RowCount > 0)
			{
				//da Cells[0] = ID unsichtbar ist, nehmen wir die nchste
				dataGridViewGaeste->CurrentCell = dataGridViewGaeste->Rows[aktZeile]->Cells[1];
			}
			else
			{
				schliessenGaesteBoxen();
			}
		}

		Void oeffnenGaesteBoxen()
		{
			buttonGaesteAendern->Enabled = true;
			buttonGaesteLoeschen->Enabled = true;
		}

		Void schliessenGaesteBoxen()
		{
			textBoxGaesteName->Clear();
			textBoxGaesteVorname->Clear();
			textBoxGaesteKurzName->Clear();
			textBoxGaesteTelefon->Clear();
			textBoxGaesteEinrichtung->Clear();
		
			buttonGaesteAendern->Enabled = false;
			buttonGaesteLoeschen->Enabled = false;
		}

		Void selectGaesteElement_Click(Object^  sender, EventArgs^  e)
		{
			if (dataGridViewGaeste->SelectedRows->Count > 0)
			{
				aktGaesteID = bestimmeDataGridViewIndex(dataGridViewGaeste);

				Gast^ tempGast = dbAssistent->getGaeste(aktGaesteID);
				if (tempGast != nullptr)
				{
					textBoxGaesteName->Text = tempGast->Gastname;
					textBoxGaesteVorname->Text = tempGast->Vorname;
					textBoxGaesteKurzName->Text = tempGast->Kurzname;
					textBoxGaesteEinrichtung->Text = dbAssistent->getEinrichtung(aktGaesteID);
					textBoxGaesteTelefon->Text = tempGast->Telefon;
					textBoxGaesteBestellungen->Text = Convert::ToString(dbAssistent->getGaesteBestellungenGesamt(AktGaesteID));
				}

				oeffnenGaesteBoxen();
			}
		}

		Void buttonGaesteAendern_Click(Object^  sender, EventArgs^  e)
		{
			aktGaesteID = bestimmeDataGridViewIndex(dataGridViewGaeste);

			GaesteWerte^ gaesteAendern = gcnew GaesteWerte(this, dbAssistent);
			gaesteAendern->ShowDialog();

			refreshGaesteDaten();
		}

		Void buttonGaesteLoeschen_Click(Object^  sender, EventArgs^  e)
		{
			aktGaesteID = bestimmeDataGridViewIndex(dataGridViewGaeste);

			dbAssistent->deleteGaeste(aktGaesteID);

			aktGaesteID = 0;

			refreshGaesteDaten();

			//Lschen von Gsten knnte Auswirkungen auf bereits bestehende Bestellungen haben
			aktBestellungenID = 0;

			refreshBestellungenDaten();
		}

		Void buttonGaesteNeu_Click(Object^  sender, EventArgs^  e)
		{
			//aktGaesteID = -1 heit, da die GaesteWerte Form einen neuen Gast anlegen soll
			aktGaesteID = -1;

			GaesteWerte^ gaesteNeu = gcnew GaesteWerte(this, dbAssistent);
			gaesteNeu->ShowDialog();

			//das mu leider sein, weil sonst neue Stze verloren gehen
			checkBoxGaesteFiltern->Checked = false;

			refreshGaesteDaten();
		}

		Void checkBoxGaesteFiltern_CheckedChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktGaesteID = 0;

			if (checkBoxGaesteFiltern->Checked)
			{
				textBoxGaesteFiltern->Enabled = true;
			}
			else
			{
				textBoxGaesteFiltern->Enabled = false;
			}

			refreshGaesteDaten();
		}

		Void textBoxGaesteFiltern_TextChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktGaesteID = 0;

			if (textBoxGaesteFiltern->Text->Length == 0)
			{
				checkBoxGaesteFiltern->Checked = false;
			}

			refreshGaesteDaten();
		}

		//Menue
		Void beendenToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			Application::Exit();
		}

		Void listeToolStripMenuItem_Click(Object^  sender, EventArgs^  e) 
		{
			KuchenBasarListe^ basarListe = gcnew KuchenBasarListe(this, dbAssistent);
			basarListe->ShowDialog();
		}

		Void FormMain_FormClosing(Object^  sender, FormClosingEventArgs^  e) 
		{
			 dbAssistent->closeDataBase();
		}

		Void tabControl1_SelectedIndexChanged(Object^  sender, EventArgs^  e) 
		{
			switch (tabControl1->SelectedIndex)
			{
			case 0: 
				selectBestellungenElement_Click(gcnew Object, gcnew EventArgs);
				refreshBestellungenDaten();
				break;
			case 1: 
				selectKuchenElement_Click(gcnew Object, gcnew EventArgs);
				refreshKuchenDaten();
				break;
			case 2: 			
				selectGaesteElement_Click(gcnew Object, gcnew EventArgs);
				refreshGaesteDaten();
				break;
			default:
				break;
			}
		}

		Void infoToolStripMenuItem_Click(Object^  sender, EventArgs^  e) 
		{
			MessageBox::Show("Kuchen Basar\n\nAbschluprojekt fr den C++ Visual .NET Kurs\n\nBernd Schubert, Alfatraining Rostock\n\n24.11.-05.12.2014");
		}
};
}