/////////////////////////////////////////90////////////////////////////////////////////
#pragma once

#ifndef _IKUCHENBASAR
#define _IKUCHENBASAR
#include "IKuchenBasar.h"
#endif

#include "GaesteM.h"
#include "KuchenM.h"
#include "BestellungenM.h"
#include "KuchenBasarListe.h"
#include "KuchenWerte.h"
#include "GaesteWerte.h"

//TODO:
// nach SQL umstellen
// dann Inhalte festlegen und Strukturen ndern...

namespace KuchenBasar {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	public ref class FormMain : public System::Windows::Forms::Form, IKuchenBasar
	{

	private:
		int aktGaesteID;
		int aktKuchenID;
		int aktBestellungenID;

		GaesteM^ gaesteverwaltung;
		KuchenM^ kuchenverwaltung;
        BestellungenM^ bestellungenverwaltung;

	public:
		virtual property int AktGaesteID
		{
			virtual void set(int value)
			{
				aktGaesteID = value;
			}

			virtual int get()
			{
				return aktGaesteID;
			}
		}

		virtual property int AktKuchenID
		{
			virtual void set(int value)
			{
				aktKuchenID = value;
			}

			virtual int get()
			{
				return aktKuchenID;
			}
		}

		virtual property int AktBestellungenID
		{
			virtual void set(int value)
			{
				aktBestellungenID = value;
			}

			virtual int get()
			{
				return aktBestellungenID;
			}
		}

	public:

		FormMain(void)
		{
			InitializeComponent();
			gaesteverwaltung = gcnew GaesteM();
			kuchenverwaltung = gcnew KuchenM();
			bestellungenverwaltung = gcnew BestellungenM();

			aktGaesteID = 0;
			aktKuchenID = 0;
			aktBestellungenID = 0;

			initBestellungenBoxen();

			refreshGaesteDaten();
			refreshKuchenDaten();
			refreshBestellungenDaten();
		}

	protected:

		~FormMain()
		{
			//			delete gaesteverwaltung;
			//			delete kuchenverwaltung;
			//			delete bestellungenverwaltung;

			if (components)
			{
				delete components;
			}
		}

	private: System::Windows::Forms::TabControl^  tabControl1;

	private: System::Windows::Forms::TabPage^  tabPageGaeste;
	private: System::Windows::Forms::SplitContainer^  splitContainerGaeste;
	private: System::Windows::Forms::DataGridView^  dataGridViewGaeste;

	private: System::Windows::Forms::TextBox^  textBoxGaesteID;
	private: System::Windows::Forms::TextBox^  textBoxGaesteName;
	private: System::Windows::Forms::TextBox^  textBoxGaesteVorname;
	private: System::Windows::Forms::TextBox^  textBoxGaesteFirma;
	private: System::Windows::Forms::TextBox^  textBoxGaesteMobile;
	private: System::Windows::Forms::TextBox^  textBoxGaesteEmail;

	private: System::Windows::Forms::Label^  labelGaesteID;
	private: System::Windows::Forms::Label^  labelGaesteName;
	private: System::Windows::Forms::Label^  labelGaesteVorname;
	private: System::Windows::Forms::Label^  labelGaesteFirma;
	private: System::Windows::Forms::Label^  labelGaesteMobile;
	private: System::Windows::Forms::Label^  labelGaesteEmail;

	private: System::Windows::Forms::TextBox^  textBoxGaesteFiltern;
	private: System::Windows::Forms::CheckBox^  checkBoxGaesteFiltern;
	private: System::Windows::Forms::Label^  labelGaesteFiltern;
    private: System::Windows::Forms::Button^  buttonGaesteAendern;

	private: System::Windows::Forms::Button^  buttonGaesteNeu;
	private: System::Windows::Forms::Button^  buttonGaesteLoeschen;

	private: System::Windows::Forms::TabPage^  tabPageKuchen;
	private: System::Windows::Forms::SplitContainer^  splitContainerKuchen;
	private: System::Windows::Forms::DataGridView^  dataGridViewKuchen;

	private: System::Windows::Forms::TextBox^  textBoxKuchenID;
	private: System::Windows::Forms::TextBox^  textBoxKuchenAnbieter;
	private: System::Windows::Forms::TextBox^  textBoxKuchenSorte;
	private: System::Windows::Forms::TextBox^  textBoxKuchenBeschreibung;
	private: System::Windows::Forms::TextBox^  textBoxKuchenAnzahl;
	private: System::Windows::Forms::TextBox^  textBoxKuchenAbgabedatum;
	private: System::Windows::Forms::CheckBox^  checkBoxKuchenDiabetikergeeignet;

	private: System::Windows::Forms::Label^  labelKuchenID;
	private: System::Windows::Forms::Label^  labelKuchenAnbieter;
	private: System::Windows::Forms::Label^  labelKuchenSorte;
	private: System::Windows::Forms::Label^  labelKuchenBeschreibung;
	private: System::Windows::Forms::Label^  labelKuchenAnzahl;
	private: System::Windows::Forms::Label^  labelKuchenAbgabedatum;

	private: System::Windows::Forms::TextBox^  textBoxKuchenFiltern;
	private: System::Windows::Forms::CheckBox^  checkBoxKuchenFiltern;
	private: System::Windows::Forms::Label^  labelKuchenFilter;

	private: System::Windows::Forms::Button^  buttonKuchenNeu;
	private: System::Windows::Forms::Button^  buttonKuchenLoeschen;
    private: System::Windows::Forms::Button^  buttonKuchenAendern;

	private: System::Windows::Forms::TabPage^  tabPageBestellungen;
	private: System::Windows::Forms::SplitContainer^  splitContainerBestellungen;
	private: System::Windows::Forms::DataGridView^  dataGridViewBestellungen;

	private: System::Windows::Forms::TextBox^  textBoxBestellungenID;
	private: System::Windows::Forms::DateTimePicker^  dateTimePickerBestellungenDatum;
	private: System::Windows::Forms::NumericUpDown^  numericUpDownBestellungenMenge;
	private: System::Windows::Forms::CheckBox^  checkBoxBestellungenBezahlt;
	private: System::Windows::Forms::ComboBox^  comboBoxBestellungenKuchenID;
	private: System::Windows::Forms::ComboBox^  comboBoxBestellungenGaesteID;

	private: System::Windows::Forms::Label^  labelBestellungenID;
	private: System::Windows::Forms::Label^  labelBestellungenGaesteID;
	private: System::Windows::Forms::Label^  labelBestellungenKuchenID;
	private: System::Windows::Forms::Label^  labelBestellungenMenge;
	private: System::Windows::Forms::Label^  labelBestellungenDatum;

	private: System::Windows::Forms::CheckBox^  checkBoxBestellungenFiltern;
	private: System::Windows::Forms::TextBox^  textBoxBestellungenFiltern;
	private: System::Windows::Forms::Label^  labelBestellungenFiltern;

	private: System::Windows::Forms::Button^  buttonBestellungenNeu;
	private: System::Windows::Forms::Button^  buttonBestellungenLoeschen;
	private: System::Windows::Forms::Button^  buttonBestellungenSpeichern;

	private: System::Windows::Forms::MenuStrip^  menuStrip1;
	private: System::Windows::Forms::ToolStripMenuItem^  dateiToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  lesenToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  sichernToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  beendenToolStripMenuItem;

	private: System::Windows::Forms::ToolStripMenuItem^  lesenGaesteToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  sichernGaesteToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  lesenKuchenToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  sichernKuchenToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  lesenBestellungenToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  sichernBestellungenToolStripMenuItem;
	private: System::Windows::Forms::ToolStripMenuItem^  listeToolStripMenuItem;

	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
			this->splitContainerGaeste = (gcnew System::Windows::Forms::SplitContainer());
			this->dataGridViewGaeste = (gcnew System::Windows::Forms::DataGridView());
			this->textBoxGaesteFiltern = (gcnew System::Windows::Forms::TextBox());
			this->checkBoxGaesteFiltern = (gcnew System::Windows::Forms::CheckBox());
			this->labelGaesteFiltern = (gcnew System::Windows::Forms::Label());
			this->textBoxGaesteID = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteName = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteVorname = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteFirma = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteMobile = (gcnew System::Windows::Forms::TextBox());
			this->textBoxGaesteEmail = (gcnew System::Windows::Forms::TextBox());
			this->labelGaesteID = (gcnew System::Windows::Forms::Label());
			this->labelGaesteName = (gcnew System::Windows::Forms::Label());
			this->labelGaesteVorname = (gcnew System::Windows::Forms::Label());
			this->labelGaesteFirma = (gcnew System::Windows::Forms::Label());
			this->labelGaesteMobile = (gcnew System::Windows::Forms::Label());
			this->labelGaesteEmail = (gcnew System::Windows::Forms::Label());
			this->buttonGaesteNeu = (gcnew System::Windows::Forms::Button());
			this->buttonGaesteLoeschen = (gcnew System::Windows::Forms::Button());
			this->buttonGaesteAendern = (gcnew System::Windows::Forms::Button());
			this->menuStrip1 = (gcnew System::Windows::Forms::MenuStrip());
			this->dateiToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->lesenToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->lesenGaesteToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->lesenKuchenToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->lesenBestellungenToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->sichernToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->sichernGaesteToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->sichernKuchenToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->sichernBestellungenToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->beendenToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->listeToolStripMenuItem = (gcnew System::Windows::Forms::ToolStripMenuItem());
			this->tabControl1 = (gcnew System::Windows::Forms::TabControl());
			this->tabPageGaeste = (gcnew System::Windows::Forms::TabPage());
			this->tabPageKuchen = (gcnew System::Windows::Forms::TabPage());
			this->splitContainerKuchen = (gcnew System::Windows::Forms::SplitContainer());
			this->dataGridViewKuchen = (gcnew System::Windows::Forms::DataGridView());
			this->checkBoxKuchenDiabetikergeeignet = (gcnew System::Windows::Forms::CheckBox());
			this->textBoxKuchenAnzahl = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenAbgabedatum = (gcnew System::Windows::Forms::TextBox());
			this->checkBoxKuchenFiltern = (gcnew System::Windows::Forms::CheckBox());
			this->labelKuchenAnzahl = (gcnew System::Windows::Forms::Label());
			this->labelKuchenAbgabedatum = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenFiltern = (gcnew System::Windows::Forms::TextBox());
			this->labelKuchenFilter = (gcnew System::Windows::Forms::Label());
			this->textBoxKuchenID = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenAnbieter = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenSorte = (gcnew System::Windows::Forms::TextBox());
			this->textBoxKuchenBeschreibung = (gcnew System::Windows::Forms::TextBox());
			this->labelKuchenID = (gcnew System::Windows::Forms::Label());
			this->labelKuchenAnbieter = (gcnew System::Windows::Forms::Label());
			this->labelKuchenSorte = (gcnew System::Windows::Forms::Label());
			this->labelKuchenBeschreibung = (gcnew System::Windows::Forms::Label());
			this->buttonKuchenNeu = (gcnew System::Windows::Forms::Button());
			this->buttonKuchenLoeschen = (gcnew System::Windows::Forms::Button());
			this->buttonKuchenAendern = (gcnew System::Windows::Forms::Button());
			this->tabPageBestellungen = (gcnew System::Windows::Forms::TabPage());
			this->splitContainerBestellungen = (gcnew System::Windows::Forms::SplitContainer());
			this->dataGridViewBestellungen = (gcnew System::Windows::Forms::DataGridView());
			this->checkBoxBestellungenBezahlt = (gcnew System::Windows::Forms::CheckBox());
			this->comboBoxBestellungenKuchenID = (gcnew System::Windows::Forms::ComboBox());
			this->comboBoxBestellungenGaesteID = (gcnew System::Windows::Forms::ComboBox());
			this->checkBoxBestellungenFiltern = (gcnew System::Windows::Forms::CheckBox());
			this->labelBestellungenMenge = (gcnew System::Windows::Forms::Label());
			this->labelBestellungenDatum = (gcnew System::Windows::Forms::Label());
			this->dateTimePickerBestellungenDatum = (gcnew System::Windows::Forms::DateTimePicker());
			this->numericUpDownBestellungenMenge = (gcnew System::Windows::Forms::NumericUpDown());
			this->textBoxBestellungenFiltern = (gcnew System::Windows::Forms::TextBox());
			this->labelBestellungenFiltern = (gcnew System::Windows::Forms::Label());
			this->textBoxBestellungenID = (gcnew System::Windows::Forms::TextBox());
			this->labelBestellungenID = (gcnew System::Windows::Forms::Label());
			this->labelBestellungenGaesteID = (gcnew System::Windows::Forms::Label());
			this->labelBestellungenKuchenID = (gcnew System::Windows::Forms::Label());
			this->buttonBestellungenNeu = (gcnew System::Windows::Forms::Button());
			this->buttonBestellungenLoeschen = (gcnew System::Windows::Forms::Button());
			this->buttonBestellungenSpeichern = (gcnew System::Windows::Forms::Button());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerGaeste))->BeginInit();
			this->splitContainerGaeste->Panel1->SuspendLayout();
			this->splitContainerGaeste->Panel2->SuspendLayout();
			this->splitContainerGaeste->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewGaeste))->BeginInit();
			this->menuStrip1->SuspendLayout();
			this->tabControl1->SuspendLayout();
			this->tabPageGaeste->SuspendLayout();
			this->tabPageKuchen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerKuchen))->BeginInit();
			this->splitContainerKuchen->Panel1->SuspendLayout();
			this->splitContainerKuchen->Panel2->SuspendLayout();
			this->splitContainerKuchen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewKuchen))->BeginInit();
			this->tabPageBestellungen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerBestellungen))->BeginInit();
			this->splitContainerBestellungen->Panel1->SuspendLayout();
			this->splitContainerBestellungen->Panel2->SuspendLayout();
			this->splitContainerBestellungen->SuspendLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewBestellungen))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numericUpDownBestellungenMenge))->BeginInit();
			this->SuspendLayout();
			// 
			// splitContainerGaeste
			// 
			this->splitContainerGaeste->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitContainerGaeste->Location = System::Drawing::Point(3, 3);
			this->splitContainerGaeste->Name = L"splitContainerGaeste";
			// 
			// splitContainerGaeste.Panel1
			// 
			this->splitContainerGaeste->Panel1->Controls->Add(this->dataGridViewGaeste);
			// 
			// splitContainerGaeste.Panel2
			// 
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteFiltern);
			this->splitContainerGaeste->Panel2->Controls->Add(this->checkBoxGaesteFiltern);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteFiltern);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteID);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteName);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteVorname);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteFirma);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteMobile);
			this->splitContainerGaeste->Panel2->Controls->Add(this->textBoxGaesteEmail);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteID);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteName);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteVorname);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteFirma);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteMobile);
			this->splitContainerGaeste->Panel2->Controls->Add(this->labelGaesteEmail);
			this->splitContainerGaeste->Panel2->Controls->Add(this->buttonGaesteNeu);
			this->splitContainerGaeste->Panel2->Controls->Add(this->buttonGaesteLoeschen);
			this->splitContainerGaeste->Panel2->Controls->Add(this->buttonGaesteAendern);
			this->splitContainerGaeste->Size = System::Drawing::Size(1206, 474);
			this->splitContainerGaeste->SplitterDistance = 651;
			this->splitContainerGaeste->TabIndex = 0;
			// 
			// dataGridViewGaeste
			// 
			this->dataGridViewGaeste->AllowUserToAddRows = false;
			this->dataGridViewGaeste->AllowUserToDeleteRows = false;
			this->dataGridViewGaeste->AutoSizeColumnsMode = System::Windows::Forms::DataGridViewAutoSizeColumnsMode::Fill;
			this->dataGridViewGaeste->AutoSizeRowsMode = System::Windows::Forms::DataGridViewAutoSizeRowsMode::AllCells;
			this->dataGridViewGaeste->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewGaeste->Dock = System::Windows::Forms::DockStyle::Fill;
			this->dataGridViewGaeste->Location = System::Drawing::Point(0, 0);
			this->dataGridViewGaeste->MultiSelect = false;
			this->dataGridViewGaeste->Name = L"dataGridViewGaeste";
			this->dataGridViewGaeste->ReadOnly = true;
			this->dataGridViewGaeste->SelectionMode = System::Windows::Forms::DataGridViewSelectionMode::FullRowSelect;
			this->dataGridViewGaeste->Size = System::Drawing::Size(651, 474);
			this->dataGridViewGaeste->TabIndex = 0;
			this->dataGridViewGaeste->SelectionChanged += gcnew System::EventHandler(this, &FormMain::selectGaesteElement_Click);
			// 
			// textBoxGaesteFiltern
			// 
			this->textBoxGaesteFiltern->Location = System::Drawing::Point(188, 345);
			this->textBoxGaesteFiltern->Name = L"textBoxGaesteFiltern";
			this->textBoxGaesteFiltern->Size = System::Drawing::Size(145, 20);
			this->textBoxGaesteFiltern->TabIndex = 15;
			this->textBoxGaesteFiltern->TextChanged += gcnew System::EventHandler(this, &FormMain::textBoxGaesteFiltern_TextChanged);
			// 
			// checkBoxGaesteFiltern
			// 
			this->checkBoxGaesteFiltern->AutoSize = true;
			this->checkBoxGaesteFiltern->Location = System::Drawing::Point(25, 345);
			this->checkBoxGaesteFiltern->Name = L"checkBoxGaesteFiltern";
			this->checkBoxGaesteFiltern->Size = System::Drawing::Size(54, 17);
			this->checkBoxGaesteFiltern->TabIndex = 14;
			this->checkBoxGaesteFiltern->Text = L"Filtern";
			this->checkBoxGaesteFiltern->UseVisualStyleBackColor = true;
			this->checkBoxGaesteFiltern->CheckedChanged += gcnew System::EventHandler(this, &FormMain::checkBoxGaesteFiltern_CheckedChanged);
			// 
			// labelGaesteFiltern
			// 
			this->labelGaesteFiltern->AutoSize = true;
			this->labelGaesteFiltern->Location = System::Drawing::Point(119, 346);
			this->labelGaesteFiltern->Name = L"labelGaesteFiltern";
			this->labelGaesteFiltern->Size = System::Drawing::Size(31, 13);
			this->labelGaesteFiltern->TabIndex = 13;
			this->labelGaesteFiltern->Text = L"nach";
			// 
			// textBoxGaesteID
			// 
			this->textBoxGaesteID->Enabled = false;
			this->textBoxGaesteID->Location = System::Drawing::Point(95, 32);
			this->textBoxGaesteID->Name = L"textBoxGaesteID";
			this->textBoxGaesteID->ReadOnly = true;
			this->textBoxGaesteID->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteID->TabIndex = 1;
			// 
			// textBoxGaesteName
			// 
			this->textBoxGaesteName->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteName->Location = System::Drawing::Point(95, 75);
			this->textBoxGaesteName->Name = L"textBoxGaesteName";
			this->textBoxGaesteName->ReadOnly = true;
			this->textBoxGaesteName->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteName->TabIndex = 2;
			// 
			// textBoxGaesteVorname
			// 
			this->textBoxGaesteVorname->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteVorname->Location = System::Drawing::Point(95, 122);
			this->textBoxGaesteVorname->Name = L"textBoxGaesteVorname";
			this->textBoxGaesteVorname->ReadOnly = true;
			this->textBoxGaesteVorname->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteVorname->TabIndex = 3;
			// 
			// textBoxGaesteFirma
			// 
			this->textBoxGaesteFirma->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteFirma->Location = System::Drawing::Point(95, 174);
			this->textBoxGaesteFirma->Name = L"textBoxGaesteFirma";
			this->textBoxGaesteFirma->ReadOnly = true;
			this->textBoxGaesteFirma->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteFirma->TabIndex = 4;
			// 
			// textBoxGaesteMobile
			// 
			this->textBoxGaesteMobile->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteMobile->Location = System::Drawing::Point(95, 232);
			this->textBoxGaesteMobile->Name = L"textBoxGaesteMobile";
			this->textBoxGaesteMobile->ReadOnly = true;
			this->textBoxGaesteMobile->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteMobile->TabIndex = 5;
			// 
			// textBoxGaesteEmail
			// 
			this->textBoxGaesteEmail->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxGaesteEmail->Location = System::Drawing::Point(95, 292);
			this->textBoxGaesteEmail->Name = L"textBoxGaesteEmail";
			this->textBoxGaesteEmail->ReadOnly = true;
			this->textBoxGaesteEmail->Size = System::Drawing::Size(238, 20);
			this->textBoxGaesteEmail->TabIndex = 6;
			// 
			// labelGaesteID
			// 
			this->labelGaesteID->AutoSize = true;
			this->labelGaesteID->Location = System::Drawing::Point(38, 39);
			this->labelGaesteID->Name = L"labelGaesteID";
			this->labelGaesteID->Size = System::Drawing::Size(18, 13);
			this->labelGaesteID->TabIndex = 0;
			this->labelGaesteID->Text = L"ID";
			// 
			// labelGaesteName
			// 
			this->labelGaesteName->AutoSize = true;
			this->labelGaesteName->Location = System::Drawing::Point(24, 82);
			this->labelGaesteName->Name = L"labelGaesteName";
			this->labelGaesteName->Size = System::Drawing::Size(35, 13);
			this->labelGaesteName->TabIndex = 0;
			this->labelGaesteName->Text = L"Name";
			// 
			// labelGaesteVorname
			// 
			this->labelGaesteVorname->AutoSize = true;
			this->labelGaesteVorname->Location = System::Drawing::Point(10, 125);
			this->labelGaesteVorname->Name = L"labelGaesteVorname";
			this->labelGaesteVorname->Size = System::Drawing::Size(49, 13);
			this->labelGaesteVorname->TabIndex = 0;
			this->labelGaesteVorname->Text = L"Vorname";
			// 
			// labelGaesteFirma
			// 
			this->labelGaesteFirma->AutoSize = true;
			this->labelGaesteFirma->Location = System::Drawing::Point(27, 181);
			this->labelGaesteFirma->Name = L"labelGaesteFirma";
			this->labelGaesteFirma->Size = System::Drawing::Size(32, 13);
			this->labelGaesteFirma->TabIndex = 0;
			this->labelGaesteFirma->Text = L"Firma";
			// 
			// labelGaesteMobile
			// 
			this->labelGaesteMobile->AutoSize = true;
			this->labelGaesteMobile->Location = System::Drawing::Point(22, 239);
			this->labelGaesteMobile->Name = L"labelGaesteMobile";
			this->labelGaesteMobile->Size = System::Drawing::Size(37, 13);
			this->labelGaesteMobile->TabIndex = 0;
			this->labelGaesteMobile->Text = L"mobile";
			// 
			// labelGaesteEmail
			// 
			this->labelGaesteEmail->AutoSize = true;
			this->labelGaesteEmail->Location = System::Drawing::Point(27, 295);
			this->labelGaesteEmail->Name = L"labelGaesteEmail";
			this->labelGaesteEmail->Size = System::Drawing::Size(32, 13);
			this->labelGaesteEmail->TabIndex = 0;
			this->labelGaesteEmail->Text = L"Email";
			// 
			// buttonGaesteNeu
			// 
			this->buttonGaesteNeu->Location = System::Drawing::Point(341, 389);
			this->buttonGaesteNeu->Name = L"buttonGaesteNeu";
			this->buttonGaesteNeu->Size = System::Drawing::Size(89, 48);
			this->buttonGaesteNeu->TabIndex = 12;
			this->buttonGaesteNeu->Text = L"Neu";
			this->buttonGaesteNeu->UseVisualStyleBackColor = true;
			this->buttonGaesteNeu->Click += gcnew System::EventHandler(this, &FormMain::buttonGaesteNeu_Click);
			// 
			// buttonGaesteLoeschen
			// 
			this->buttonGaesteLoeschen->Enabled = false;
			this->buttonGaesteLoeschen->Location = System::Drawing::Point(207, 389);
			this->buttonGaesteLoeschen->Name = L"buttonGaesteLoeschen";
			this->buttonGaesteLoeschen->Size = System::Drawing::Size(89, 48);
			this->buttonGaesteLoeschen->TabIndex = 11;
			this->buttonGaesteLoeschen->Text = L"Lschen";
			this->buttonGaesteLoeschen->UseVisualStyleBackColor = true;
			this->buttonGaesteLoeschen->Click += gcnew System::EventHandler(this, &FormMain::buttonGaesteLoeschen_Click);
			// 
			// buttonGaesteAendern
			// 
			this->buttonGaesteAendern->Enabled = false;
			this->buttonGaesteAendern->Location = System::Drawing::Point(65, 389);
			this->buttonGaesteAendern->Name = L"buttonGaesteAendern";
			this->buttonGaesteAendern->Size = System::Drawing::Size(89, 48);
			this->buttonGaesteAendern->TabIndex = 10;
			this->buttonGaesteAendern->Text = L"ndern";
			this->buttonGaesteAendern->UseVisualStyleBackColor = true;
			this->buttonGaesteAendern->Click += gcnew System::EventHandler(this, &FormMain::buttonGaesteAendern_Click);
			// 
			// menuStrip1
			// 
			this->menuStrip1->Items->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(2) {
				this->dateiToolStripMenuItem,
					this->listeToolStripMenuItem
			});
			this->menuStrip1->Location = System::Drawing::Point(0, 0);
			this->menuStrip1->Name = L"menuStrip1";
			this->menuStrip1->Size = System::Drawing::Size(1220, 24);
			this->menuStrip1->TabIndex = 0;
			this->menuStrip1->Text = L"menuStrip1";
			// 
			// dateiToolStripMenuItem
			// 
			this->dateiToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {
				this->lesenToolStripMenuItem,
					this->sichernToolStripMenuItem, this->beendenToolStripMenuItem
			});
			this->dateiToolStripMenuItem->Name = L"dateiToolStripMenuItem";
			this->dateiToolStripMenuItem->Size = System::Drawing::Size(46, 20);
			this->dateiToolStripMenuItem->Text = L"Datei";
			// 
			// lesenToolStripMenuItem
			// 
			this->lesenToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {
				this->lesenGaesteToolStripMenuItem,
					this->lesenKuchenToolStripMenuItem, this->lesenBestellungenToolStripMenuItem
			});
			this->lesenToolStripMenuItem->Name = L"lesenToolStripMenuItem";
			this->lesenToolStripMenuItem->Size = System::Drawing::Size(120, 22);
			this->lesenToolStripMenuItem->Text = L"Lesen";
			// 
			// lesenGaesteToolStripMenuItem
			// 
			this->lesenGaesteToolStripMenuItem->Name = L"lesenGaesteToolStripMenuItem";
			this->lesenGaesteToolStripMenuItem->Size = System::Drawing::Size(142, 22);
			this->lesenGaesteToolStripMenuItem->Text = L"Gaeste";
			this->lesenGaesteToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::lesenGaesteToolStripMenuItem_Click);
			// 
			// lesenKuchenToolStripMenuItem
			// 
			this->lesenKuchenToolStripMenuItem->Name = L"lesenKuchenToolStripMenuItem";
			this->lesenKuchenToolStripMenuItem->Size = System::Drawing::Size(142, 22);
			this->lesenKuchenToolStripMenuItem->Text = L"Kuchen";
			this->lesenKuchenToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::lesenKuchenToolStripMenuItem_Click);
			// 
			// lesenBestellungenToolStripMenuItem
			// 
			this->lesenBestellungenToolStripMenuItem->Name = L"lesenBestellungenToolStripMenuItem";
			this->lesenBestellungenToolStripMenuItem->Size = System::Drawing::Size(142, 22);
			this->lesenBestellungenToolStripMenuItem->Text = L"Bestellungen";
			this->lesenBestellungenToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::lesenBestellungenToolStripMenuItem_Click);
			// 
			// sichernToolStripMenuItem
			// 
			this->sichernToolStripMenuItem->DropDownItems->AddRange(gcnew cli::array< System::Windows::Forms::ToolStripItem^  >(3) {
				this->sichernGaesteToolStripMenuItem,
					this->sichernKuchenToolStripMenuItem, this->sichernBestellungenToolStripMenuItem
			});
			this->sichernToolStripMenuItem->Name = L"sichernToolStripMenuItem";
			this->sichernToolStripMenuItem->Size = System::Drawing::Size(120, 22);
			this->sichernToolStripMenuItem->Text = L"Sichern";
			// 
			// sichernGaesteToolStripMenuItem
			// 
			this->sichernGaesteToolStripMenuItem->Name = L"sichernGaesteToolStripMenuItem";
			this->sichernGaesteToolStripMenuItem->Size = System::Drawing::Size(142, 22);
			this->sichernGaesteToolStripMenuItem->Text = L"Gaeste";
			this->sichernGaesteToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::sichernGaesteToolStripMenuItem_Click);
			// 
			// sichernKuchenToolStripMenuItem
			// 
			this->sichernKuchenToolStripMenuItem->Name = L"sichernKuchenToolStripMenuItem";
			this->sichernKuchenToolStripMenuItem->Size = System::Drawing::Size(142, 22);
			this->sichernKuchenToolStripMenuItem->Text = L"Kuchen";
			this->sichernKuchenToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::sichernKuchenToolStripMenuItem_Click);
			// 
			// sichernBestellungenToolStripMenuItem
			// 
			this->sichernBestellungenToolStripMenuItem->Name = L"sichernBestellungenToolStripMenuItem";
			this->sichernBestellungenToolStripMenuItem->Size = System::Drawing::Size(142, 22);
			this->sichernBestellungenToolStripMenuItem->Text = L"Bestellungen";
			this->sichernBestellungenToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::sichernBestellungenToolStripMenuItem_Click);
			// 
			// beendenToolStripMenuItem
			// 
			this->beendenToolStripMenuItem->Name = L"beendenToolStripMenuItem";
			this->beendenToolStripMenuItem->Size = System::Drawing::Size(120, 22);
			this->beendenToolStripMenuItem->Text = L"Beenden";
			this->beendenToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::beendenToolStripMenuItem_Click);
			// 
			// listeToolStripMenuItem
			// 
			this->listeToolStripMenuItem->Name = L"listeToolStripMenuItem";
			this->listeToolStripMenuItem->Size = System::Drawing::Size(43, 20);
			this->listeToolStripMenuItem->Text = L"Liste";
			this->listeToolStripMenuItem->Click += gcnew System::EventHandler(this, &FormMain::listeToolStripMenuItem_Click);
			// 
			// tabControl1
			// 
			this->tabControl1->Controls->Add(this->tabPageGaeste);
			this->tabControl1->Controls->Add(this->tabPageKuchen);
			this->tabControl1->Controls->Add(this->tabPageBestellungen);
			this->tabControl1->Dock = System::Windows::Forms::DockStyle::Fill;
			this->tabControl1->Location = System::Drawing::Point(0, 24);
			this->tabControl1->Name = L"tabControl1";
			this->tabControl1->SelectedIndex = 0;
			this->tabControl1->Size = System::Drawing::Size(1220, 506);
			this->tabControl1->TabIndex = 0;
			// 
			// tabPageGaeste
			// 
			this->tabPageGaeste->Controls->Add(this->splitContainerGaeste);
			this->tabPageGaeste->Location = System::Drawing::Point(4, 22);
			this->tabPageGaeste->Name = L"tabPageGaeste";
			this->tabPageGaeste->Padding = System::Windows::Forms::Padding(3);
			this->tabPageGaeste->Size = System::Drawing::Size(1212, 480);
			this->tabPageGaeste->TabIndex = 0;
			this->tabPageGaeste->Text = L"Gste";
			this->tabPageGaeste->UseVisualStyleBackColor = true;
			// 
			// tabPageKuchen
			// 
			this->tabPageKuchen->Controls->Add(this->splitContainerKuchen);
			this->tabPageKuchen->Location = System::Drawing::Point(4, 22);
			this->tabPageKuchen->Name = L"tabPageKuchen";
			this->tabPageKuchen->Padding = System::Windows::Forms::Padding(3);
			this->tabPageKuchen->Size = System::Drawing::Size(1212, 480);
			this->tabPageKuchen->TabIndex = 0;
			this->tabPageKuchen->Text = L"Kuchen";
			this->tabPageKuchen->UseVisualStyleBackColor = true;
			// 
			// splitContainerKuchen
			// 
			this->splitContainerKuchen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitContainerKuchen->Location = System::Drawing::Point(3, 3);
			this->splitContainerKuchen->Name = L"splitContainerKuchen";
			// 
			// splitContainerKuchen.Panel1
			// 
			this->splitContainerKuchen->Panel1->Controls->Add(this->dataGridViewKuchen);
			// 
			// splitContainerKuchen.Panel2
			// 
			this->splitContainerKuchen->Panel2->Controls->Add(this->checkBoxKuchenDiabetikergeeignet);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenAnzahl);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenAbgabedatum);
			this->splitContainerKuchen->Panel2->Controls->Add(this->checkBoxKuchenFiltern);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenAnzahl);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenAbgabedatum);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenFiltern);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenFilter);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenID);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenAnbieter);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenSorte);
			this->splitContainerKuchen->Panel2->Controls->Add(this->textBoxKuchenBeschreibung);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenID);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenAnbieter);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenSorte);
			this->splitContainerKuchen->Panel2->Controls->Add(this->labelKuchenBeschreibung);
			this->splitContainerKuchen->Panel2->Controls->Add(this->buttonKuchenNeu);
			this->splitContainerKuchen->Panel2->Controls->Add(this->buttonKuchenLoeschen);
			this->splitContainerKuchen->Panel2->Controls->Add(this->buttonKuchenAendern);
			this->splitContainerKuchen->Size = System::Drawing::Size(1206, 474);
			this->splitContainerKuchen->SplitterDistance = 648;
			this->splitContainerKuchen->TabIndex = 0;
			// 
			// dataGridViewKuchen
			// 
			this->dataGridViewKuchen->AllowUserToAddRows = false;
			this->dataGridViewKuchen->AllowUserToDeleteRows = false;
			this->dataGridViewKuchen->AutoSizeColumnsMode = System::Windows::Forms::DataGridViewAutoSizeColumnsMode::Fill;
			this->dataGridViewKuchen->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewKuchen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->dataGridViewKuchen->Location = System::Drawing::Point(0, 0);
			this->dataGridViewKuchen->Name = L"dataGridViewKuchen";
			this->dataGridViewKuchen->ReadOnly = true;
			this->dataGridViewKuchen->SelectionMode = System::Windows::Forms::DataGridViewSelectionMode::FullRowSelect;
			this->dataGridViewKuchen->Size = System::Drawing::Size(648, 474);
			this->dataGridViewKuchen->TabIndex = 0;
			this->dataGridViewKuchen->SelectionChanged += gcnew System::EventHandler(this, &FormMain::selectKuchenElement_Click);
			// 
			// checkBoxKuchenDiabetikergeeignet
			// 
			this->checkBoxKuchenDiabetikergeeignet->Anchor = static_cast<System::Windows::Forms::AnchorStyles>((System::Windows::Forms::AnchorStyles::Top | System::Windows::Forms::AnchorStyles::Right));
			this->checkBoxKuchenDiabetikergeeignet->AutoSize = true;
			this->checkBoxKuchenDiabetikergeeignet->Enabled = false;
			this->checkBoxKuchenDiabetikergeeignet->Location = System::Drawing::Point(192, 293);
			this->checkBoxKuchenDiabetikergeeignet->Name = L"checkBoxKuchenDiabetikergeeignet";
			this->checkBoxKuchenDiabetikergeeignet->Size = System::Drawing::Size(118, 17);
			this->checkBoxKuchenDiabetikergeeignet->TabIndex = 24;
			this->checkBoxKuchenDiabetikergeeignet->Text = L"Diabetiker geeignet";
			this->checkBoxKuchenDiabetikergeeignet->UseVisualStyleBackColor = true;
			// 
			// textBoxKuchenAnzahl
			// 
			this->textBoxKuchenAnzahl->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenAnzahl->Location = System::Drawing::Point(192, 258);
			this->textBoxKuchenAnzahl->Name = L"textBoxKuchenAnzahl";
			this->textBoxKuchenAnzahl->ReadOnly = true;
			this->textBoxKuchenAnzahl->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenAnzahl->TabIndex = 23;
			// 
			// textBoxKuchenAbgabedatum
			// 
			this->textBoxKuchenAbgabedatum->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenAbgabedatum->Location = System::Drawing::Point(192, 212);
			this->textBoxKuchenAbgabedatum->Name = L"textBoxKuchenAbgabedatum";
			this->textBoxKuchenAbgabedatum->ReadOnly = true;
			this->textBoxKuchenAbgabedatum->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenAbgabedatum->TabIndex = 22;
			// 
			// checkBoxKuchenFiltern
			// 
			this->checkBoxKuchenFiltern->AutoSize = true;
			this->checkBoxKuchenFiltern->Location = System::Drawing::Point(58, 328);
			this->checkBoxKuchenFiltern->Name = L"checkBoxKuchenFiltern";
			this->checkBoxKuchenFiltern->Size = System::Drawing::Size(54, 17);
			this->checkBoxKuchenFiltern->TabIndex = 21;
			this->checkBoxKuchenFiltern->Text = L"Filtern";
			this->checkBoxKuchenFiltern->UseVisualStyleBackColor = true;
			this->checkBoxKuchenFiltern->CheckedChanged += gcnew System::EventHandler(this, &FormMain::checkBoxKuchenFiltern_CheckedChanged);
			// 
			// labelKuchenAnzahl
			// 
			this->labelKuchenAnzahl->AutoSize = true;
			this->labelKuchenAnzahl->Location = System::Drawing::Point(124, 265);
			this->labelKuchenAnzahl->Name = L"labelKuchenAnzahl";
			this->labelKuchenAnzahl->Size = System::Drawing::Size(39, 13);
			this->labelKuchenAnzahl->TabIndex = 20;
			this->labelKuchenAnzahl->Text = L"Anzahl";
			// 
			// labelKuchenAbgabedatum
			// 
			this->labelKuchenAbgabedatum->AutoSize = true;
			this->labelKuchenAbgabedatum->Location = System::Drawing::Point(90, 219);
			this->labelKuchenAbgabedatum->Name = L"labelKuchenAbgabedatum";
			this->labelKuchenAbgabedatum->Size = System::Drawing::Size(73, 13);
			this->labelKuchenAbgabedatum->TabIndex = 19;
			this->labelKuchenAbgabedatum->Text = L"Abgabedatum";
			// 
			// textBoxKuchenFiltern
			// 
			this->textBoxKuchenFiltern->Enabled = false;
			this->textBoxKuchenFiltern->Location = System::Drawing::Point(233, 325);
			this->textBoxKuchenFiltern->Name = L"textBoxKuchenFiltern";
			this->textBoxKuchenFiltern->Size = System::Drawing::Size(197, 20);
			this->textBoxKuchenFiltern->TabIndex = 16;
			this->textBoxKuchenFiltern->TextChanged += gcnew System::EventHandler(this, &FormMain::textBoxKuchenFiltern_TextChanged);
			// 
			// labelKuchenFilter
			// 
			this->labelKuchenFilter->AutoSize = true;
			this->labelKuchenFilter->Location = System::Drawing::Point(171, 332);
			this->labelKuchenFilter->Name = L"labelKuchenFilter";
			this->labelKuchenFilter->Size = System::Drawing::Size(31, 13);
			this->labelKuchenFilter->TabIndex = 14;
			this->labelKuchenFilter->Text = L"nach";
			// 
			// textBoxKuchenID
			// 
			this->textBoxKuchenID->Enabled = false;
			this->textBoxKuchenID->Location = System::Drawing::Point(192, 35);
			this->textBoxKuchenID->Name = L"textBoxKuchenID";
			this->textBoxKuchenID->ReadOnly = true;
			this->textBoxKuchenID->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenID->TabIndex = 1;
			// 
			// textBoxKuchenAnbieter
			// 
			this->textBoxKuchenAnbieter->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenAnbieter->Location = System::Drawing::Point(192, 75);
			this->textBoxKuchenAnbieter->Name = L"textBoxKuchenAnbieter";
			this->textBoxKuchenAnbieter->ReadOnly = true;
			this->textBoxKuchenAnbieter->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenAnbieter->TabIndex = 2;
			// 
			// textBoxKuchenSorte
			// 
			this->textBoxKuchenSorte->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenSorte->Location = System::Drawing::Point(192, 122);
			this->textBoxKuchenSorte->Name = L"textBoxKuchenSorte";
			this->textBoxKuchenSorte->ReadOnly = true;
			this->textBoxKuchenSorte->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenSorte->TabIndex = 3;
			// 
			// textBoxKuchenBeschreibung
			// 
			this->textBoxKuchenBeschreibung->BackColor = System::Drawing::SystemColors::Window;
			this->textBoxKuchenBeschreibung->Location = System::Drawing::Point(192, 174);
			this->textBoxKuchenBeschreibung->Name = L"textBoxKuchenBeschreibung";
			this->textBoxKuchenBeschreibung->ReadOnly = true;
			this->textBoxKuchenBeschreibung->Size = System::Drawing::Size(238, 20);
			this->textBoxKuchenBeschreibung->TabIndex = 4;
			// 
			// labelKuchenID
			// 
			this->labelKuchenID->AutoSize = true;
			this->labelKuchenID->Location = System::Drawing::Point(136, 42);
			this->labelKuchenID->Name = L"labelKuchenID";
			this->labelKuchenID->Size = System::Drawing::Size(18, 13);
			this->labelKuchenID->TabIndex = 0;
			this->labelKuchenID->Text = L"ID";
			// 
			// labelKuchenAnbieter
			// 
			this->labelKuchenAnbieter->AutoSize = true;
			this->labelKuchenAnbieter->Location = System::Drawing::Point(119, 82);
			this->labelKuchenAnbieter->Name = L"labelKuchenAnbieter";
			this->labelKuchenAnbieter->Size = System::Drawing::Size(46, 13);
			this->labelKuchenAnbieter->TabIndex = 0;
			this->labelKuchenAnbieter->Text = L"Anbieter";
			// 
			// labelKuchenSorte
			// 
			this->labelKuchenSorte->AutoSize = true;
			this->labelKuchenSorte->Location = System::Drawing::Point(119, 129);
			this->labelKuchenSorte->Name = L"labelKuchenSorte";
			this->labelKuchenSorte->Size = System::Drawing::Size(32, 13);
			this->labelKuchenSorte->TabIndex = 0;
			this->labelKuchenSorte->Text = L"Sorte";
			// 
			// labelKuchenBeschreibung
			// 
			this->labelKuchenBeschreibung->AutoSize = true;
			this->labelKuchenBeschreibung->Location = System::Drawing::Point(93, 181);
			this->labelKuchenBeschreibung->Name = L"labelKuchenBeschreibung";
			this->labelKuchenBeschreibung->Size = System::Drawing::Size(72, 13);
			this->labelKuchenBeschreibung->TabIndex = 0;
			this->labelKuchenBeschreibung->Text = L"Beschreibung";
			// 
			// buttonKuchenNeu
			// 
			this->buttonKuchenNeu->Location = System::Drawing::Point(341, 389);
			this->buttonKuchenNeu->Name = L"buttonKuchenNeu";
			this->buttonKuchenNeu->Size = System::Drawing::Size(89, 48);
			this->buttonKuchenNeu->TabIndex = 12;
			this->buttonKuchenNeu->Text = L"Neu";
			this->buttonKuchenNeu->UseVisualStyleBackColor = true;
			this->buttonKuchenNeu->Click += gcnew System::EventHandler(this, &FormMain::buttonKuchenNeu_Click);
			// 
			// buttonKuchenLoeschen
			// 
			this->buttonKuchenLoeschen->Enabled = false;
			this->buttonKuchenLoeschen->Location = System::Drawing::Point(202, 389);
			this->buttonKuchenLoeschen->Name = L"buttonKuchenLoeschen";
			this->buttonKuchenLoeschen->Size = System::Drawing::Size(89, 48);
			this->buttonKuchenLoeschen->TabIndex = 11;
			this->buttonKuchenLoeschen->Text = L"Lschen";
			this->buttonKuchenLoeschen->UseVisualStyleBackColor = true;
			this->buttonKuchenLoeschen->Click += gcnew System::EventHandler(this, &FormMain::buttonKuchenLoeschen_Click);
			// 
			// buttonKuchenAendern
			// 
			this->buttonKuchenAendern->Enabled = false;
			this->buttonKuchenAendern->Location = System::Drawing::Point(58, 389);
			this->buttonKuchenAendern->Name = L"buttonKuchenAendern";
			this->buttonKuchenAendern->Size = System::Drawing::Size(89, 48);
			this->buttonKuchenAendern->TabIndex = 10;
			this->buttonKuchenAendern->Text = L"ndern";
			this->buttonKuchenAendern->UseVisualStyleBackColor = true;
			this->buttonKuchenAendern->Click += gcnew System::EventHandler(this, &FormMain::buttonKuchenAendern_Click);
			// 
			// tabPageBestellungen
			// 
			this->tabPageBestellungen->Controls->Add(this->splitContainerBestellungen);
			this->tabPageBestellungen->Location = System::Drawing::Point(4, 22);
			this->tabPageBestellungen->Name = L"tabPageBestellungen";
			this->tabPageBestellungen->Padding = System::Windows::Forms::Padding(3);
			this->tabPageBestellungen->Size = System::Drawing::Size(1212, 480);
			this->tabPageBestellungen->TabIndex = 1;
			this->tabPageBestellungen->Text = L"Bestellungen";
			this->tabPageBestellungen->UseVisualStyleBackColor = true;
			// 
			// splitContainerBestellungen
			// 
			this->splitContainerBestellungen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->splitContainerBestellungen->Location = System::Drawing::Point(3, 3);
			this->splitContainerBestellungen->Name = L"splitContainerBestellungen";
			// 
			// splitContainerBestellungen.Panel1
			// 
			this->splitContainerBestellungen->Panel1->Controls->Add(this->dataGridViewBestellungen);
			// 
			// splitContainerBestellungen.Panel2
			// 
			this->splitContainerBestellungen->Panel2->Controls->Add(this->checkBoxBestellungenBezahlt);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->comboBoxBestellungenKuchenID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->comboBoxBestellungenGaesteID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->checkBoxBestellungenFiltern);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenMenge);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenDatum);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->dateTimePickerBestellungenDatum);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->numericUpDownBestellungenMenge);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->textBoxBestellungenFiltern);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenFiltern);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->textBoxBestellungenID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenGaesteID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->labelBestellungenKuchenID);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->buttonBestellungenNeu);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->buttonBestellungenLoeschen);
			this->splitContainerBestellungen->Panel2->Controls->Add(this->buttonBestellungenSpeichern);
			this->splitContainerBestellungen->Size = System::Drawing::Size(1206, 474);
			this->splitContainerBestellungen->SplitterDistance = 648;
			this->splitContainerBestellungen->TabIndex = 1;
			// 
			// dataGridViewBestellungen
			// 
			this->dataGridViewBestellungen->AllowUserToAddRows = false;
			this->dataGridViewBestellungen->AllowUserToDeleteRows = false;
			this->dataGridViewBestellungen->AutoSizeColumnsMode = System::Windows::Forms::DataGridViewAutoSizeColumnsMode::Fill;
			this->dataGridViewBestellungen->ColumnHeadersHeightSizeMode = System::Windows::Forms::DataGridViewColumnHeadersHeightSizeMode::AutoSize;
			this->dataGridViewBestellungen->Dock = System::Windows::Forms::DockStyle::Fill;
			this->dataGridViewBestellungen->Location = System::Drawing::Point(0, 0);
			this->dataGridViewBestellungen->Name = L"dataGridViewBestellungen";
			this->dataGridViewBestellungen->ReadOnly = true;
			this->dataGridViewBestellungen->SelectionMode = System::Windows::Forms::DataGridViewSelectionMode::FullRowSelect;
			this->dataGridViewBestellungen->Size = System::Drawing::Size(648, 474);
			this->dataGridViewBestellungen->TabIndex = 0;
			this->dataGridViewBestellungen->SelectionChanged += gcnew System::EventHandler(this, &FormMain::selectBestellungenElement_Click);
			// 
			// checkBoxBestellungenBezahlt
			// 
			this->checkBoxBestellungenBezahlt->AutoSize = true;
			this->checkBoxBestellungenBezahlt->Location = System::Drawing::Point(197, 258);
			this->checkBoxBestellungenBezahlt->Name = L"checkBoxBestellungenBezahlt";
			this->checkBoxBestellungenBezahlt->Size = System::Drawing::Size(61, 17);
			this->checkBoxBestellungenBezahlt->TabIndex = 6;
			this->checkBoxBestellungenBezahlt->Text = L"Bezahlt";
			this->checkBoxBestellungenBezahlt->UseVisualStyleBackColor = true;
			// 
			// comboBoxBestellungenKuchenID
			// 
			this->comboBoxBestellungenKuchenID->FormattingEnabled = true;
			this->comboBoxBestellungenKuchenID->Location = System::Drawing::Point(192, 118);
			this->comboBoxBestellungenKuchenID->Name = L"comboBoxBestellungenKuchenID";
			this->comboBoxBestellungenKuchenID->Size = System::Drawing::Size(238, 21);
			this->comboBoxBestellungenKuchenID->TabIndex = 3;
			// 
			// comboBoxBestellungenGaesteID
			// 
			this->comboBoxBestellungenGaesteID->FormattingEnabled = true;
			this->comboBoxBestellungenGaesteID->Location = System::Drawing::Point(192, 79);
			this->comboBoxBestellungenGaesteID->Name = L"comboBoxBestellungenGaesteID";
			this->comboBoxBestellungenGaesteID->Size = System::Drawing::Size(238, 21);
			this->comboBoxBestellungenGaesteID->TabIndex = 2;
			// 
			// checkBoxBestellungenFiltern
			// 
			this->checkBoxBestellungenFiltern->AutoSize = true;
			this->checkBoxBestellungenFiltern->Location = System::Drawing::Point(58, 328);
			this->checkBoxBestellungenFiltern->Name = L"checkBoxBestellungenFiltern";
			this->checkBoxBestellungenFiltern->Size = System::Drawing::Size(54, 17);
			this->checkBoxBestellungenFiltern->TabIndex = 21;
			this->checkBoxBestellungenFiltern->Text = L"Filtern";
			this->checkBoxBestellungenFiltern->UseVisualStyleBackColor = true;
			this->checkBoxBestellungenFiltern->CheckedChanged += gcnew System::EventHandler(this, &FormMain::checkBoxBestellungenFiltern_CheckedChanged);
			// 
			// labelBestellungenMenge
			// 
			this->labelBestellungenMenge->AutoSize = true;
			this->labelBestellungenMenge->Location = System::Drawing::Point(114, 213);
			this->labelBestellungenMenge->Name = L"labelBestellungenMenge";
			this->labelBestellungenMenge->Size = System::Drawing::Size(40, 13);
			this->labelBestellungenMenge->TabIndex = 0;
			this->labelBestellungenMenge->Text = L"Menge";
			// 
			// labelBestellungenDatum
			// 
			this->labelBestellungenDatum->AutoSize = true;
			this->labelBestellungenDatum->Location = System::Drawing::Point(90, 166);
			this->labelBestellungenDatum->Name = L"labelBestellungenDatum";
			this->labelBestellungenDatum->Size = System::Drawing::Size(67, 13);
			this->labelBestellungenDatum->TabIndex = 0;
			this->labelBestellungenDatum->Text = L"Bestelldatum";
			// 
			// dateTimePickerBestellungenDatum
			// 
			this->dateTimePickerBestellungenDatum->DropDownAlign = System::Windows::Forms::LeftRightAlignment::Right;
			this->dateTimePickerBestellungenDatum->Format = System::Windows::Forms::DateTimePickerFormat::Custom;
			this->dateTimePickerBestellungenDatum->Location = System::Drawing::Point(192, 160);
			this->dateTimePickerBestellungenDatum->Name = L"dateTimePickerBestellungenDatum";
			this->dateTimePickerBestellungenDatum->Size = System::Drawing::Size(238, 20);
			this->dateTimePickerBestellungenDatum->TabIndex = 4;
			// 
			// numericUpDownBestellungenMenge
			// 
			this->numericUpDownBestellungenMenge->Location = System::Drawing::Point(192, 206);
			this->numericUpDownBestellungenMenge->Name = L"numericUpDownBestellungenMenge";
			this->numericUpDownBestellungenMenge->Size = System::Drawing::Size(238, 20);
			this->numericUpDownBestellungenMenge->TabIndex = 5;
			// 
			// textBoxBestellungenFiltern
			// 
			this->textBoxBestellungenFiltern->Enabled = false;
			this->textBoxBestellungenFiltern->Location = System::Drawing::Point(233, 325);
			this->textBoxBestellungenFiltern->Name = L"textBoxBestellungenFiltern";
			this->textBoxBestellungenFiltern->Size = System::Drawing::Size(197, 20);
			this->textBoxBestellungenFiltern->TabIndex = 22;
			this->textBoxBestellungenFiltern->TextChanged += gcnew System::EventHandler(this, &FormMain::textBoxBestellungenFiltern_TextChanged);
			// 
			// labelBestellungenFiltern
			// 
			this->labelBestellungenFiltern->AutoSize = true;
			this->labelBestellungenFiltern->Location = System::Drawing::Point(171, 332);
			this->labelBestellungenFiltern->Name = L"labelBestellungenFiltern";
			this->labelBestellungenFiltern->Size = System::Drawing::Size(31, 13);
			this->labelBestellungenFiltern->TabIndex = 0;
			this->labelBestellungenFiltern->Text = L"nach";
			// 
			// textBoxBestellungenID
			// 
			this->textBoxBestellungenID->Enabled = false;
			this->textBoxBestellungenID->Location = System::Drawing::Point(192, 35);
			this->textBoxBestellungenID->Name = L"textBoxBestellungenID";
			this->textBoxBestellungenID->ReadOnly = true;
			this->textBoxBestellungenID->Size = System::Drawing::Size(238, 20);
			this->textBoxBestellungenID->TabIndex = 1;
			// 
			// labelBestellungenID
			// 
			this->labelBestellungenID->AutoSize = true;
			this->labelBestellungenID->Location = System::Drawing::Point(136, 42);
			this->labelBestellungenID->Name = L"labelBestellungenID";
			this->labelBestellungenID->Size = System::Drawing::Size(18, 13);
			this->labelBestellungenID->TabIndex = 0;
			this->labelBestellungenID->Text = L"ID";
			// 
			// labelBestellungenGaesteID
			// 
			this->labelBestellungenGaesteID->AutoSize = true;
			this->labelBestellungenGaesteID->Location = System::Drawing::Point(119, 82);
			this->labelBestellungenGaesteID->Name = L"labelBestellungenGaesteID";
			this->labelBestellungenGaesteID->Size = System::Drawing::Size(29, 13);
			this->labelBestellungenGaesteID->TabIndex = 0;
			this->labelBestellungenGaesteID->Text = L"Gast";
			// 
			// labelBestellungenKuchenID
			// 
			this->labelBestellungenKuchenID->AutoSize = true;
			this->labelBestellungenKuchenID->Location = System::Drawing::Point(101, 121);
			this->labelBestellungenKuchenID->Name = L"labelBestellungenKuchenID";
			this->labelBestellungenKuchenID->Size = System::Drawing::Size(44, 13);
			this->labelBestellungenKuchenID->TabIndex = 0;
			this->labelBestellungenKuchenID->Text = L"Kuchen";
			// 
			// buttonBestellungenNeu
			// 
			this->buttonBestellungenNeu->Location = System::Drawing::Point(341, 389);
			this->buttonBestellungenNeu->Name = L"buttonBestellungenNeu";
			this->buttonBestellungenNeu->Size = System::Drawing::Size(89, 48);
			this->buttonBestellungenNeu->TabIndex = 12;
			this->buttonBestellungenNeu->Text = L"Neu";
			this->buttonBestellungenNeu->UseVisualStyleBackColor = true;
			this->buttonBestellungenNeu->Click += gcnew System::EventHandler(this, &FormMain::buttonBestellungenNeu_Click);
			// 
			// buttonBestellungenLoeschen
			// 
			this->buttonBestellungenLoeschen->Enabled = false;
			this->buttonBestellungenLoeschen->Location = System::Drawing::Point(202, 389);
			this->buttonBestellungenLoeschen->Name = L"buttonBestellungenLoeschen";
			this->buttonBestellungenLoeschen->Size = System::Drawing::Size(89, 48);
			this->buttonBestellungenLoeschen->TabIndex = 11;
			this->buttonBestellungenLoeschen->Text = L"Lschen";
			this->buttonBestellungenLoeschen->UseVisualStyleBackColor = true;
			this->buttonBestellungenLoeschen->Click += gcnew System::EventHandler(this, &FormMain::buttonBestellungenLoeschen_Click);
			// 
			// buttonBestellungenSpeichern
			// 
			this->buttonBestellungenSpeichern->Enabled = false;
			this->buttonBestellungenSpeichern->Location = System::Drawing::Point(58, 389);
			this->buttonBestellungenSpeichern->Name = L"buttonBestellungenSpeichern";
			this->buttonBestellungenSpeichern->Size = System::Drawing::Size(89, 48);
			this->buttonBestellungenSpeichern->TabIndex = 10;
			this->buttonBestellungenSpeichern->Text = L"Speichern";
			this->buttonBestellungenSpeichern->UseVisualStyleBackColor = true;
			this->buttonBestellungenSpeichern->Click += gcnew System::EventHandler(this, &FormMain::buttonBestellungenSpeichern_Click);
			// 
			// FormMain
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::SystemColors::Window;
			this->BackgroundImageLayout = System::Windows::Forms::ImageLayout::None;
			this->ClientSize = System::Drawing::Size(1220, 530);
			this->Controls->Add(this->tabControl1);
			this->Controls->Add(this->menuStrip1);
			this->MainMenuStrip = this->menuStrip1;
			this->Name = L"FormMain";
			this->Text = L"Kuchen Test mit Files";
			this->splitContainerGaeste->Panel1->ResumeLayout(false);
			this->splitContainerGaeste->Panel2->ResumeLayout(false);
			this->splitContainerGaeste->Panel2->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerGaeste))->EndInit();
			this->splitContainerGaeste->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewGaeste))->EndInit();
			this->menuStrip1->ResumeLayout(false);
			this->menuStrip1->PerformLayout();
			this->tabControl1->ResumeLayout(false);
			this->tabPageGaeste->ResumeLayout(false);
			this->tabPageKuchen->ResumeLayout(false);
			this->splitContainerKuchen->Panel1->ResumeLayout(false);
			this->splitContainerKuchen->Panel2->ResumeLayout(false);
			this->splitContainerKuchen->Panel2->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerKuchen))->EndInit();
			this->splitContainerKuchen->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewKuchen))->EndInit();
			this->tabPageBestellungen->ResumeLayout(false);
			this->splitContainerBestellungen->Panel1->ResumeLayout(false);
			this->splitContainerBestellungen->Panel2->ResumeLayout(false);
			this->splitContainerBestellungen->Panel2->PerformLayout();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->splitContainerBestellungen))->EndInit();
			this->splitContainerBestellungen->ResumeLayout(false);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->dataGridViewBestellungen))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^>(this->numericUpDownBestellungenMenge))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private:
		int bestimmeDataGridViewZeile(DataGridView^ aktDataGridView, int aktID)
		{
			Object^ tempObjID;
			int tempID;

			//aktID == 0 heit, es ist keine ID aktiv, soll aber die erste aktiviert werden
			if (aktID == 0)
			{
				return 0;
			}

			//aktID == -1 heit, es ist keine ID aktiv, soll aber die letzte aktiviert werden
			int anzahl = aktDataGridView->Rows->Count;

			if (aktID < 0)
			{
				return anzahl - 1;
			}

			//Suche die Zeile, wo die ID drin steht
			for (int i = 0; i < anzahl; i++)
			{
				tempObjID = aktDataGridView->Rows[i]->Cells["ID"]->Value;
				if (tempObjID != nullptr)
				{
					tempID = Convert::ToInt32(tempObjID->ToString());
					if (tempID == aktID)
					{
						return i;
					}
				}
			}

			//nicht gefunden -> erste Zeile
			return 0;
		}

		//Kuchen
		Void refreshKuchenDaten()
		{
			//int berndM1 = aktKuchenID;
			//int berndK1 = aktGaesteID;

			int retteMich = aktKuchenID;

			if (checkBoxKuchenFiltern->Checked)
			{
				String^ suchmaske = textBoxKuchenFiltern->Text;
				dataGridViewKuchen->DataSource = kuchenverwaltung->getTabelle(suchmaske);
			}
			else
			{
				dataGridViewKuchen->DataSource = kuchenverwaltung->getTabelle();
			}

			//nach Lschen/Speichern/Neu soll mglichst auf dem aktuellen Satz positioniert sein
			//nach Lschen: am besten der erste
			//nach Neu: der letzte
			//nach Speichern: die gleiche ID
			//wegen des Filters ist aber erst jetzt klar, welche Zeile das sein kann...

			//ich habe keine Erklrung dafr, aber die aktGaesteID geht hier kapputt??? 
			//mglicherweise berschreibt das DataSource der dataGridView 
			//beim Modulwechsel die einfachen Variablen
			//int berndM2 = aktKuchenID;
			//int berndK2 = aktGaesteID;

			aktKuchenID = retteMich;

			int aktZeile = bestimmeDataGridViewZeile(dataGridViewKuchen, aktKuchenID);

			if (aktZeile > 0 || aktKuchenID > 0 || dataGridViewKuchen->RowCount == 1)
			{
				dataGridViewKuchen->CurrentCell = dataGridViewKuchen->Rows[aktZeile]->Cells[0];
			}
			else
			{
				schliessenKuchenBoxen();
			}
		}

		Void oeffnenKuchenBoxen()
		{
			buttonKuchenAendern->Enabled = true;
			buttonKuchenLoeschen->Enabled = true;
		}

		Void schliessenKuchenBoxen()
		{
			textBoxKuchenID->Clear();
			textBoxKuchenAnbieter->Clear();
			textBoxKuchenSorte->Clear();
			textBoxKuchenBeschreibung->Clear();
			textBoxKuchenAnzahl->Clear();
			textBoxKuchenAbgabedatum->Clear();
			checkBoxKuchenDiabetikergeeignet->Checked = false;

			buttonKuchenAendern->Enabled = false;
			buttonKuchenLoeschen->Enabled = false;
		}

		Void selectKuchenElement_Click(Object^  sender, EventArgs^  e)
		{
			if (dataGridViewKuchen->SelectedRows->Count > 0)
			{
				Object^ tempID = dataGridViewKuchen->SelectedRows[0]->Cells["ID"]->Value;

				if (tempID != nullptr)
				{
					aktKuchenID = Convert::ToInt32(tempID->ToString());
					textBoxKuchenID->Text = aktKuchenID.ToString();
				}

				Kuchen^ tempKuchen = kuchenverwaltung->getInfos(aktKuchenID);
				if (tempKuchen != nullptr)
				{
					textBoxKuchenAnbieter->Text = tempKuchen->Anbieter;
					textBoxKuchenSorte->Text = tempKuchen->Sorte;
					textBoxKuchenBeschreibung->Text = tempKuchen->Beschreibung;
					textBoxKuchenAbgabedatum->Text = tempKuchen->Abgabedatum->ToString();
					textBoxKuchenAnzahl->Text = tempKuchen->Anzahl.ToString();
					checkBoxKuchenDiabetikergeeignet->Checked = tempKuchen->Diabetikergeeignet;
				}

				oeffnenKuchenBoxen();
			}
		}

		Void buttonKuchenAendern_Click(Object^  sender, EventArgs^  e)
		{
			String^ tempID = textBoxKuchenID->Text;
			if (tempID->Length > 0)
			{
				aktKuchenID = Convert::ToInt32(tempID->ToString());

				KuchenWerte^ kuchenAendern = gcnew KuchenWerte(this, kuchenverwaltung);
				kuchenAendern->ShowDialog();

				refreshKuchenDaten();
			}
		}

		Void buttonKuchenLoeschen_Click(Object^  sender, EventArgs^  e)
		{
			String^ tempID = textBoxKuchenID->Text;
			if (tempID->Length > 0)
			{
				aktKuchenID = Convert::ToInt32(tempID->ToString());

				kuchenverwaltung->del(aktKuchenID);

				aktKuchenID = 0;

				refreshKuchenDaten();
			}
		}

		Void buttonKuchenNeu_Click(Object^  sender, EventArgs^  e)
		{
			Kuchen^ tempKuchen = gcnew Kuchen();

			kuchenverwaltung->neu(tempKuchen);

			//tempkuchen hlt schon die aktuelle ID
			aktKuchenID = tempKuchen->Id;

			KuchenWerte^ kuchenNeu = gcnew KuchenWerte(this, kuchenverwaltung);
			kuchenNeu->ShowDialog();

			//das mu leider sein, weil sonst neue Stze verloren gehen
			checkBoxKuchenFiltern->Checked = false;
			aktKuchenID = -1;

			refreshKuchenDaten();
		}

		Void checkBoxKuchenFiltern_CheckedChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktKuchenID = 0;

			if (checkBoxKuchenFiltern->Checked)
			{
				textBoxKuchenFiltern->Enabled = true;
			}
			else
			{
				textBoxKuchenFiltern->Enabled = false;
			}

			refreshKuchenDaten();
		}

		Void textBoxKuchenFiltern_TextChanged(Object^  sender, EventArgs^  e)
		{
			//leider mssen wir hier die aktuellen Keys aufgeben, da die Suchmaske alles verndern kann
			aktKuchenID = 0;

			if (textBoxKuchenFiltern->Text->Length == 0)
			{
				checkBoxKuchenFiltern->Checked = false;
			}

			refreshKuchenDaten();
		}

		//Gast
		Void refreshGaesteDaten()
		{
			int retteMich = aktGaesteID;
			
			if (checkBoxGaesteFiltern->Checked)
			{
				String^ suchmaske = textBoxGaesteFiltern->Text;
				dataGridViewGaeste->DataSource = gaesteverwaltung->getTabelle(suchmaske);
			}
			else
			{
				dataGridViewGaeste->DataSource = gaesteverwaltung->getTabelle();
			}

			aktGaesteID = retteMich;

			int aktZeile = bestimmeDataGridViewZeile(dataGridViewGaeste, aktGaesteID);

			if (aktZeile > 0 || aktGaesteID > 0 || dataGridViewGaeste->RowCount == 1)
			{
				dataGridViewGaeste->CurrentCell = dataGridViewGaeste->Rows[aktZeile]->Cells[0];
			}
			else
			{
				schliessenGaesteBoxen();
			}
		}

		Void oeffnenGaesteBoxen()
		{
			buttonGaesteAendern->Enabled = true;
			buttonGaesteLoeschen->Enabled = true;
		}

		Void schliessenGaesteBoxen()
		{
			textBoxGaesteID->Clear();
			textBoxGaesteName->Clear();
			textBoxGaesteVorname->Clear();
			textBoxGaesteFirma->Clear();
			textBoxGaesteMobile->Clear();
			textBoxGaesteEmail->Clear();

			buttonGaesteAendern->Enabled = false;
			buttonGaesteLoeschen->Enabled = false;
		}

		Void selectGaesteElement_Click(Object^  sender, EventArgs^  e)
		{
			if (dataGridViewGaeste->SelectedRows->Count > 0)
			{
				Object^ tempID = dataGridViewGaeste->SelectedRows[0]->Cells["ID"]->Value;

				if (tempID != nullptr)
				{
					aktGaesteID = Convert::ToInt32(tempID->ToString());
					textBoxGaesteID->Text = aktGaesteID.ToString();
				}

				Gast^ tempGast = gaesteverwaltung->getInfos(aktGaesteID);
				if (tempGast != nullptr)
				{
					textBoxGaesteName->Text = tempGast->Name;
					textBoxGaesteVorname->Text = tempGast->Vorname;
					textBoxGaesteFirma->Text = tempGast->Firma;
					textBoxGaesteMobile->Text = tempGast->Mobile;
					textBoxGaesteEmail->Text = tempGast->Email;
					textBoxGaesteName->Text = tempGast->Name;
				}

				oeffnenGaesteBoxen();
			}
		}

		Void buttonGaesteAendern_Click(Object^  sender, EventArgs^  e)
		{
			String^ tempID = textBoxGaesteID->Text;
			if (tempID->Length > 0)
			{
				aktGaesteID = Convert::ToInt32(tempID->ToString());

				GaesteWerte^ gaesteAendern = gcnew GaesteWerte(this, gaesteverwaltung);
				gaesteAendern->ShowDialog();

				refreshGaesteDaten();
			}
		}

		Void buttonGaesteLoeschen_Click(Object^  sender, EventArgs^  e)
		{
			String^ tempID = textBoxGaesteID->Text;
			if (tempID->Length > 0)
			{
				aktGaesteID = Convert::ToInt32(tempID->ToString());
	
				gaesteverwaltung->del(aktGaesteID);

				aktGaesteID = 0;

				refreshGaesteDaten();
			}
		}

		Void buttonGaesteNeu_Click(Object^  sender, EventArgs^  e)
		{
			Gast^ tempGast = gcnew Gast();

			gaesteverwaltung->neu(tempGast);

			aktGaesteID = tempGast->Id;

			GaesteWerte^ gaesteNeu = gcnew GaesteWerte(this, gaesteverwaltung);
			gaesteNeu->ShowDialog();

			checkBoxGaesteFiltern->Checked = false;
			aktGaesteID = -1;

			refreshGaesteDaten();
		}

		Void checkBoxGaesteFiltern_CheckedChanged(Object^  sender, EventArgs^  e)
		{
			aktGaesteID = 0;

			if (checkBoxGaesteFiltern->Checked)
			{
				textBoxGaesteFiltern->Enabled = true;
			}
			else
			{
				textBoxGaesteFiltern->Enabled = false;
			}

			refreshGaesteDaten();
		}

		Void textBoxGaesteFiltern_TextChanged(Object^  sender, EventArgs^  e)
		{
			aktGaesteID = 0;

			if (textBoxGaesteFiltern->Text->Length == 0)
			{
				checkBoxGaesteFiltern->Checked = false;
			}

			refreshGaesteDaten();
		}

		//Bestellungen
		Void refreshBestellungenDaten()
		{
			int retteMich = aktBestellungenID;

			if (checkBoxBestellungenFiltern->Checked)
			{
				String^ suchmaske = textBoxBestellungenFiltern->Text;
				dataGridViewBestellungen->DataSource = bestellungenverwaltung->getTabelle(suchmaske);
			}
			else
			{
				dataGridViewBestellungen->DataSource = bestellungenverwaltung->getTabelle();
			}

			aktBestellungenID = retteMich;

			int aktZeile = bestimmeDataGridViewZeile(dataGridViewBestellungen, aktBestellungenID);

			if (aktZeile > 0 || aktBestellungenID > 0 || dataGridViewBestellungen->RowCount == 1)
			{
				dataGridViewBestellungen->CurrentCell = dataGridViewBestellungen->Rows[aktZeile]->Cells[0];
			}
			else
			{
				schliessenBestellungenBoxen();
			}
		}

		Void initBestellungenBoxen()
		{
			comboBoxBestellungenGaesteID->Items->Clear();
			comboBoxBestellungenKuchenID->Items->Clear();
			for (int i = 0; i <= 100; i++)
			{
				comboBoxBestellungenGaesteID->Items->Add(i.ToString());
				comboBoxBestellungenKuchenID->Items->Add(i.ToString());
			}
		}

		Void oeffnenBestellungenBoxen()
		{
			comboBoxBestellungenGaesteID->Enabled = true;
			comboBoxBestellungenKuchenID->Enabled = true;
			numericUpDownBestellungenMenge->ReadOnly = false;
			dateTimePickerBestellungenDatum->Enabled = true;
			checkBoxBestellungenBezahlt->Enabled = true;

			buttonBestellungenSpeichern->Enabled = true;
			buttonBestellungenLoeschen->Enabled = true;
		}

		Void schliessenBestellungenBoxen()
		{
			textBoxBestellungenID->Clear();
			comboBoxBestellungenGaesteID->SelectedIndex = 0;
			comboBoxBestellungenKuchenID->SelectedIndex = 0;
			numericUpDownBestellungenMenge->Value = 0;
			dateTimePickerBestellungenDatum->Value = DateTime(2000, 1, 1);
			checkBoxBestellungenBezahlt->Checked = false;

			comboBoxBestellungenGaesteID->Enabled = false;
			comboBoxBestellungenKuchenID->Enabled = false;
			numericUpDownBestellungenMenge->ReadOnly = true;
			dateTimePickerBestellungenDatum->Enabled = false;
			checkBoxBestellungenBezahlt->Enabled = false;

			buttonBestellungenSpeichern->Enabled = false;
			buttonBestellungenLoeschen->Enabled = false;
		}

		Void selectBestellungenElement_Click(Object^  sender, EventArgs^  e)
		{
			if (dataGridViewBestellungen->SelectedRows->Count > 0)
			{
				Object^ tempID = dataGridViewBestellungen->SelectedRows[0]->Cells["ID"]->Value;

				if (tempID != nullptr)
				{
					aktBestellungenID = Convert::ToInt32(tempID->ToString());
					textBoxBestellungenID->Text = aktBestellungenID.ToString();
				}

				Bestellung^ tempBestellung = bestellungenverwaltung->getInfos(aktBestellungenID);
				if (tempBestellung != nullptr)
				{
					comboBoxBestellungenGaesteID->SelectedIndex = tempBestellung->GaesteId;
					comboBoxBestellungenKuchenID->SelectedIndex = tempBestellung->KuchenId;

					dateTimePickerBestellungenDatum->CustomFormat = "dd.MMM.yyyy, HH:mm:ss";
					dateTimePickerBestellungenDatum->Text = tempBestellung->Datum->ToString();
	
					numericUpDownBestellungenMenge->Value = tempBestellung->Menge;
					
					checkBoxBestellungenBezahlt->Checked = tempBestellung->Bezahlt;
				}

				oeffnenBestellungenBoxen();
			}
		}

		Void buttonBestellungenSpeichern_Click(Object^  sender, EventArgs^  e)
		{
			String^ tempID = textBoxBestellungenID->Text;
			if (tempID->Length > 0)
			{
				Bestellung^ tempBestellung = gcnew Bestellung();

				aktBestellungenID = Convert::ToInt32(tempID->ToString());
				tempBestellung->Id = aktBestellungenID;

				tempBestellung->GaesteId = comboBoxBestellungenGaesteID->SelectedIndex;
				tempBestellung->KuchenId = comboBoxBestellungenKuchenID->SelectedIndex;

				//wieder Entfernen des Custom Format Kommas
				String^ tempDatum = dateTimePickerBestellungenDatum->Text->Replace(',', ' ');
				tempBestellung->Datum = Convert::ToDateTime(tempDatum);

				tempBestellung->Menge = Convert::ToInt32(numericUpDownBestellungenMenge->Value);

				tempBestellung->Bezahlt = checkBoxBestellungenBezahlt->Checked;

				bestellungenverwaltung->setInfos(tempBestellung);

				refreshBestellungenDaten();
			}
		}

		Void buttonBestellungenLoeschen_Click(Object^  sender, EventArgs^  e)
		{
			String^ tempID = textBoxBestellungenID->Text;
			if (tempID->Length > 0)
			{
				aktBestellungenID = Convert::ToInt32(tempID->ToString());

				bestellungenverwaltung->del(aktBestellungenID);

				aktBestellungenID = 0;

				refreshBestellungenDaten();
			}
		}

		Void buttonBestellungenNeu_Click(Object^  sender, EventArgs^  e)
		{
			Bestellung^ tempBestellung = gcnew Bestellung();

			bestellungenverwaltung->neu(tempBestellung);

			checkBoxBestellungenFiltern->Checked = false;
			aktBestellungenID = -1;

			refreshBestellungenDaten();
		}

		Void checkBoxBestellungenFiltern_CheckedChanged(Object^  sender, EventArgs^  e)
		{
			aktBestellungenID = 0;

			if (checkBoxBestellungenFiltern->Checked)
			{
				textBoxBestellungenFiltern->Enabled = true;
			}
			else
			{
				textBoxBestellungenFiltern->Enabled = false;
			}

			refreshBestellungenDaten();
		}

		Void textBoxBestellungenFiltern_TextChanged(Object^  sender, EventArgs^  e)
		{
			aktBestellungenID = 0;

			if (textBoxBestellungenFiltern->Text->Length == 0)
			{
				checkBoxBestellungenFiltern->Checked = false;
			}

			refreshBestellungenDaten();
		}

		//Menue
		Void lesenGaesteToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			aktGaesteID = 0;

			gaesteverwaltung->lesen();
			refreshGaesteDaten();
		}

		Void sichernGaesteToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			gaesteverwaltung->speichern();
			schliessenGaesteBoxen();
		}

		Void lesenKuchenToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			aktKuchenID = 0;

			kuchenverwaltung->lesen();
			refreshKuchenDaten();
		}

		Void sichernKuchenToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			kuchenverwaltung->speichern();
			schliessenKuchenBoxen();
		}
	
		Void lesenBestellungenToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			aktBestellungenID = 0;

			bestellungenverwaltung->lesen();
			refreshBestellungenDaten();
		}

		Void sichernBestellungenToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			bestellungenverwaltung->speichern();
			schliessenBestellungenBoxen();
		}

		Void beendenToolStripMenuItem_Click(Object^  sender, EventArgs^  e)
		{
			Application::Exit();
		}

		Void listeToolStripMenuItem_Click(Object^  sender, EventArgs^  e) 
		{
			KuchenBasarListe^ basarListe = gcnew KuchenBasarListe(this);
			basarListe->ShowDialog();
		}
};
}