#pragma once
#ifndef _IKUCHENBASAR
#include "IKuchenBasar.h"
#endif

namespace KuchenBasar {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;

	public ref class GaesteWerte : public System::Windows::Forms::Form
	{
	private:
		IKuchenBasar^ kuchenBasarIntern;
		GaesteM^ gaesteVerwaltungIntern;
        Gast^ aktGast;

	public:
		GaesteWerte(IKuchenBasar^ kuchenbasar, GaesteM^ gaesteverwaltung)
		{
			InitializeComponent();

			kuchenBasarIntern = kuchenbasar;
			gaesteVerwaltungIntern = gaesteverwaltung;

			aktGast = gaesteVerwaltungIntern->getInfos(kuchenbasar->AktGaesteID);

			textBoxName->Text = aktGast->Name;
			textBoxVorname->Text = aktGast->Vorname;
			textBoxFirma->Text = aktGast->Firma;
			textBoxMobile->Text = aktGast->Mobile;
			textBoxEmail->Text = aktGast->Email;
		}

	protected:
		/// <summary>
		/// Verwendete Ressourcen bereinigen.
		/// </summary>
		~GaesteWerte()
		{
			if (components)
			{
				delete components;
			}
		}

	private: System::Windows::Forms::Button^  buttonSpeichern;
	private: System::Windows::Forms::Button^  buttonAbbruch;

	private: System::Windows::Forms::TextBox^  textBoxName;
	private: System::Windows::Forms::TextBox^  textBoxVorname;
	private: System::Windows::Forms::TextBox^  textBoxFirma;
	private: System::Windows::Forms::TextBox^  textBoxEmail;
	private: System::Windows::Forms::TextBox^  textBoxMobile;
			 
	private: System::Windows::Forms::Label^  labelName;
	private: System::Windows::Forms::Label^  labelVorname;
	private: System::Windows::Forms::Label^  labelFirma;
	private: System::Windows::Forms::Label^  labelMobile;
	private: System::Windows::Forms::Label^  labelEmail;

	private:
		/// <summary>
		/// Erforderliche Designervariable.
		/// </summary>
		System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
			this->buttonSpeichern = (gcnew System::Windows::Forms::Button());
			this->buttonAbbruch = (gcnew System::Windows::Forms::Button());
			this->labelEmail = (gcnew System::Windows::Forms::Label());
			this->textBoxName = (gcnew System::Windows::Forms::TextBox());
			this->textBoxVorname = (gcnew System::Windows::Forms::TextBox());
			this->textBoxFirma = (gcnew System::Windows::Forms::TextBox());
			this->labelName = (gcnew System::Windows::Forms::Label());
			this->labelVorname = (gcnew System::Windows::Forms::Label());
			this->labelFirma = (gcnew System::Windows::Forms::Label());
			this->labelMobile = (gcnew System::Windows::Forms::Label());
			this->textBoxEmail = (gcnew System::Windows::Forms::TextBox());
			this->textBoxMobile = (gcnew System::Windows::Forms::TextBox());
			this->SuspendLayout();
			// 
			// buttonSpeichern
			// 
			this->buttonSpeichern->Location = System::Drawing::Point(540, 59);
			this->buttonSpeichern->Name = L"buttonSpeichern";
			this->buttonSpeichern->Size = System::Drawing::Size(165, 43);
			this->buttonSpeichern->TabIndex = 0;
			this->buttonSpeichern->Text = L"Speichern";
			this->buttonSpeichern->UseVisualStyleBackColor = true;
			this->buttonSpeichern->Click += gcnew System::EventHandler(this, &GaesteWerte::buttonSpeichern_Click);
			// 
			// buttonAbbruch
			// 
			this->buttonAbbruch->Location = System::Drawing::Point(540, 264);
			this->buttonAbbruch->Name = L"buttonAbbruch";
			this->buttonAbbruch->Size = System::Drawing::Size(165, 40);
			this->buttonAbbruch->TabIndex = 1;
			this->buttonAbbruch->Text = L"Abbruch";
			this->buttonAbbruch->UseVisualStyleBackColor = true;
			this->buttonAbbruch->Click += gcnew System::EventHandler(this, &GaesteWerte::buttonAbbruch_Click);
			// 
			// labelEmail
			// 
			this->labelEmail->AutoSize = true;
			this->labelEmail->Location = System::Drawing::Point(62, 283);
			this->labelEmail->Name = L"labelEmail";
			this->labelEmail->Size = System::Drawing::Size(39, 13);
			this->labelEmail->TabIndex = 5;
			this->labelEmail->Text = L"Email";
			// 
			// textBoxName
			// 
			this->textBoxName->Location = System::Drawing::Point(164, 31);
			this->textBoxName->Name = L"textBoxName";
			this->textBoxName->Size = System::Drawing::Size(203, 20);
			this->textBoxName->TabIndex = 6;
			// 
			// textBoxVorname
			// 
			this->textBoxVorname->Location = System::Drawing::Point(165, 100);
			this->textBoxVorname->Name = L"textBoxVorname";
			this->textBoxVorname->Size = System::Drawing::Size(202, 20);
			this->textBoxVorname->TabIndex = 7;
			// 
			// textBoxFirma
			// 
			this->textBoxFirma->Location = System::Drawing::Point(164, 160);
			this->textBoxFirma->Name = L"textBoxFirma";
			this->textBoxFirma->Size = System::Drawing::Size(201, 20);
			this->textBoxFirma->TabIndex = 8;
			// 
			// labelName
			// 
			this->labelName->AutoSize = true;
			this->labelName->Location = System::Drawing::Point(54, 38);
			this->labelName->Name = L"labelName";
			this->labelName->Size = System::Drawing::Size(46, 13);
			this->labelName->TabIndex = 10;
			this->labelName->Text = L"Name";
			// 
			// labelVorname
			// 
			this->labelVorname->AutoSize = true;
			this->labelVorname->Location = System::Drawing::Point(68, 103);
			this->labelVorname->Name = L"labelVorname";
			this->labelVorname->Size = System::Drawing::Size(32, 13);
			this->labelVorname->TabIndex = 11;
			this->labelVorname->Text = L"Vorname";
			// 
			// labelFirma
			// 
			this->labelFirma->AutoSize = true;
			this->labelFirma->Location = System::Drawing::Point(28, 167);
			this->labelFirma->Name = L"labelFirma";
			this->labelFirma->Size = System::Drawing::Size(72, 13);
			this->labelFirma->TabIndex = 12;
			this->labelFirma->Text = L"Firma";
			// 
			// labelMobile
			// 
			this->labelMobile->AutoSize = true;
			this->labelMobile->Location = System::Drawing::Point(28, 226);
			this->labelMobile->Name = L"labelMobile";
			this->labelMobile->Size = System::Drawing::Size(73, 13);
			this->labelMobile->TabIndex = 13;
			this->labelMobile->Text = L"Mobile";
			// 
			// textBoxEmail
			// 
			this->textBoxEmail->Location = System::Drawing::Point(166, 280);
			this->textBoxEmail->Name = L"textBoxEmail";
			this->textBoxEmail->Size = System::Drawing::Size(201, 20);
			this->textBoxEmail->TabIndex = 14;
			// 
			// textBoxMobile
			// 
			this->textBoxMobile->Location = System::Drawing::Point(166, 219);
			this->textBoxMobile->Name = L"textBoxMobile";
			this->textBoxMobile->Size = System::Drawing::Size(201, 20);
			this->textBoxMobile->TabIndex = 15;
			// 
			// GaesteWerte
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->BackColor = System::Drawing::SystemColors::Window;
			this->ClientSize = System::Drawing::Size(806, 357);
			this->Controls->Add(this->textBoxMobile);
			this->Controls->Add(this->textBoxEmail);
			this->Controls->Add(this->labelMobile);
			this->Controls->Add(this->labelFirma);
			this->Controls->Add(this->labelVorname);
			this->Controls->Add(this->labelName);
			this->Controls->Add(this->textBoxFirma);
			this->Controls->Add(this->textBoxVorname);
			this->Controls->Add(this->textBoxName);
			this->Controls->Add(this->labelEmail);
			this->Controls->Add(this->buttonAbbruch);
			this->Controls->Add(this->buttonSpeichern);
			this->Name = L"GaesteWerte";
			this->Text = L"GaesteWerte";
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion
	private:
		Void buttonAbbruch_Click(Object^  sender, EventArgs^  e)
		{
			this->Close();
		}

		Void buttonSpeichern_Click(Object^  sender, EventArgs^  e)
		{
			aktGast->Id = kuchenBasarIntern->AktGaesteID;

			aktGast->Name = textBoxName->Text;
			aktGast->Vorname = textBoxVorname->Text;
			aktGast->Firma = textBoxFirma->Text;
			aktGast->Mobile = textBoxMobile->Text;
			aktGast->Email = textBoxEmail->Text;

			gaesteVerwaltungIntern->setInfos(aktGast);

			this->Close();
		}
	};
}
